name = ChooseTranslationTable({"Renewable Hamlet", zh="移植树藤"}) --Better Great Leafy Stalks
description = ChooseTranslationTable({"Great Leafy Stalks have a 70% chance to spawn 1 fireflies every day time. They can also be collided to drop some resources. Added Tree Nut, Above-Average Leafy Stalk and (raw or cooked) Tuber Granules.", zh="巨大树干现在有70%几率每天生成一个萤火虫。它们也可以被碰撞来掉落一些资源。添加树果、高出平均值的树干以及生熟块茎颗粒。"})                      
author = "WL"  
version = "2.0.1" --2024.1.23

--更好的巨大树干，可再生的哈姆雷特

forumthread = "/:)/"

api_version = 6
priority = -10

dont_starve_compatible = false
reign_of_giants_compatible = false 
shipwrecked_compatible = false 
hamlet_compatible = true
dst_compatible = false  

icon_atlas = ""
icon = ""

configuration_options =
{
    {
		name    = "Language",  --语言选项--
		label   = ChooseTranslationTable({"Language", zh="语言"}),
		options =
		{   --If there will be more languages, data (true, false) need to be changed to "xxx"
			{description = "English", data = true},
			{description = "中文", data = false}
		},
		default = true,
	},
    {
		name    = "Frequency",  --生成频率--
		label   = ChooseTranslationTable({"Frequency", zh="频率"}),
		options =
		{
			{description = ChooseTranslationTable({"None", zh="无"}), data = 0},
			{description = ChooseTranslationTable({"Less", zh="少"}), data = 1440},
			{description = ChooseTranslationTable({"Default", zh="默认"}), data = 480},
			{description = ChooseTranslationTable({"More", zh="多"}), data = 240},
			{description = ChooseTranslationTable({"Lots", zh="很多"}), data = 120}	
		},
		default = 480,
	},
    {
		name    = "Lily Pond Refresh",  --荷花池刷新--
		label   = ChooseTranslationTable({"Lily Pond Refresh", zh="莲花池刷新"}),
		options =
		{
			{description = ChooseTranslationTable({"None", zh="无"}), data = 0},
			{description = ChooseTranslationTable({"Less", zh="少"}), data = 1440},
			{description = ChooseTranslationTable({"Default", zh="默认"}), data = 480},
			{description = ChooseTranslationTable({"More", zh="多"}), data = 240},
			{description = ChooseTranslationTable({"Lots", zh="很多"}), data = 120}	
		},
		default = 480,
	},	
    {
		name    = "Pinacle Refresh",  --山峰刷新--
		label   = ChooseTranslationTable({"Pinacle Refresh", zh="山峰刷新"}),
		options =
		{
			{description = ChooseTranslationTable({"None", zh="无"}), data = 0},
			{description = ChooseTranslationTable({"Less", zh="少"}), data = 1440},
			{description = ChooseTranslationTable({"Default", zh="默认"}), data = 480},
			{description = ChooseTranslationTable({"More", zh="多"}), data = 240},
			{description = ChooseTranslationTable({"Lots", zh="很多"}), data = 120}	
		},
		default = 480,
	},		
	{
		name    = "Tree Nut",  --树果--
		label   = ChooseTranslationTable({"Tree Nut", zh="树果"}),
		options =
		{
			{description = ChooseTranslationTable({"None", zh="无"}), data = 0},
			{description = ChooseTranslationTable({"Less", zh="少"}), data = 0.001},
			{description = ChooseTranslationTable({"Default", zh="默认"}), data = 0.01},
			{description = ChooseTranslationTable({"More", zh="多"}), data = 0.1},
			{description = ChooseTranslationTable({"Lots", zh="很多"}), data = 0.4}	
		},
		default = 0.01,
	},
	{
		name    = "Stalk Spawn",  --树干生成--
		label   = ChooseTranslationTable({"Stalk Spawn", zh="树干生成"}),
		options =
		{
			{description = ChooseTranslationTable({"None", zh="无"}), data = 0},
			{description = ChooseTranslationTable({"Less", zh="少"}), data = 2400},
			{description = ChooseTranslationTable({"Default", zh="默认"}), data = 480},
			{description = ChooseTranslationTable({"More", zh="多"}), data = 240},
			{description = ChooseTranslationTable({"Lots", zh="很多"}), data = 120}	
		},
		default = 480,
	},
	{
		name    = "Pog Spawn",  --哈巴狸生成--
		label   = ChooseTranslationTable({"Pog Spawn", zh="哈巴狸生成"}),
		options =
		{
			{description = ChooseTranslationTable({"None", zh="无"}), data = 0},
			{description = ChooseTranslationTable({"Less", zh="少"}), data = 14400},
			{description = ChooseTranslationTable({"Default", zh="默认"}), data = 4800},
			{description = ChooseTranslationTable({"More", zh="多"}), data = 2400},
			{description = ChooseTranslationTable({"Lots", zh="很多"}), data = 1200}	
		},
		default = 4800,
	},	
	{
		name    = "Fountain Spawn",  --不老泉生成--
		label   = ChooseTranslationTable({"Fountain Spawn", zh="泉水生成"}),
		options =
		{
			{description = ChooseTranslationTable({"Yes", zh="是"}), data = true},
			{description = ChooseTranslationTable({"No", zh="否"}), data = false},	
		},
		default = true,
	},
	{
		name    = "Peagawk Spawn",  --呆望雀生成--
		label   = ChooseTranslationTable({"Peagawk Spawn", zh="呆望雀生成"}),
		options =
		{
			{description = ChooseTranslationTable({"Yes", zh="是"}), data = true},
			{description = ChooseTranslationTable({"No", zh="否"}), data = false},	
		},
		default = true,
	},	
}