GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})

if not IsDLCEnabled(PORKLAND_DLC) then return end
if GetModConfigData("Frequency") == 0 then return end

Assets = 
{		
    Asset("ANIM", "anim/oceantreenut.zip"),
	
	Asset("ATLAS", "images/inventoryimages/tree_nut.xml"),
    Asset("IMAGE", "images/inventoryimages/tree_nut.tex"),
  	Asset("ATLAS_BUILD", "images/inventoryimages/tree_nut.xml", 256),
	
	Asset("SCRIPT", "scripts/prefabs/canopyshadows.lua"),
}

PrefabFiles = 
{
	"tree_pillar_artificial",
	"treenut",
	"tuber_pollen",
}

AddMinimapAtlas("images/inventoryimages/tree_nut.xml")

RegisterInventoryItemAtlas("images/inventoryimages/tree_nut.xml", "tree_nut.tex")

TUNING.LANGUAGE = GetModConfigData("Language")
TUNING.TREE_PILLAR_CHOPS = 25
TUNING.HEAVY_SPEED_MULT = -0.85
TUNING.TREENUT_GROW_TIME = TUNING.TOTAL_DAY_TIME * 20    --20
TUNING.TREENUT_GROW_TIME_VARIANCE = TUNING.TOTAL_DAY_TIME * 10    --10
TUNING.FREQUENCY = GetModConfigData("Frequency")
TUNING.TREENUT_SPAWN_DATA = GetModConfigData("Tree Nut")
TUNING.STALK_SPAWN_DATA = GetModConfigData("Stalk Spawn")
TUNING.POG_SPAWN_DATA = GetModConfigData("Pog Spawn")
TUNING.SHADE_CANOPY_RANGE = 28
TUNING.SHADE_CANOPY_RANGE_SMALL = 22
TUNING.TREE_PILLAR_CANOPY_BUFFER = 1
TUNING.MAX_ENTITY_TEMP_UNDER_CANOPY = 65
TUNING.TREE_PILLAR_MAXCHILDREN = 1
TUNING.CLAW_PALM_TREE_MAXCHILDREN = 1
TUNING.TREE_PILLAR_RARE_CHILD_CHANCE = 0.01
TUNING.TUBERSEED_GROW_TIME = TUNING.TOTAL_DAY_TIME * 8    --20
TUNING.TUBERSEED_GROW_TIME_VARIANCE = TUNING.TOTAL_DAY_TIME * 4    --10
TUNING.TREE_PILLAR_COLLIDE_REQUIRED_PLAYER_SPEED = 12

if GetModConfigData("Language") == true then
    STRINGS.NAMES.TREENUT = "Tree Nut"
	STRINGS.NAMES.TREE_PILLAR_ARTIFICIAL = "Above-Average Leafy Stalk"
	STRINGS.NAMES.TUBER_POLLEN = "Tuber Granules"
	STRINGS.NAMES.TUBER_POLLEN_COOKED = "Burnt Tuber Granules"
	
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "Grows unscientifically."
    STRINGS.CHARACTERS.WILLOW.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "This is enough for me to burn for a while!"
    STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "Is a strong tree."
    STRINGS.CHARACTERS.WENDY.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "The happy time under the tree shade no longer exists..."
    STRINGS.CHARACTERS.WX78.DESCRIBE.TREE_PILLAR_ARTIFICIAL  = "YOU ARE VERY USEFUL TO ME, BIG UMBRELLA"
    STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "It's a pity that I can't let it reach the initial level."
    STRINGS.CHARACTERS.WOODIE.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "Enough for me to chop for a while."
    STRINGS.CHARACTERS.WAXWELL.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "Not neat enough."
    STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "Yon tree shall guard us from the treacherous sun."
    STRINGS.CHARACTERS.WEBBER.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "Now we have our own big tree!"
    STRINGS.CHARACTERS.WARLY.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "I have to make sure it bears fruit."
    STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "Biiig friend!"
    STRINGS.CHARACTERS.WAGSTAFF.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "Keep the weather out."
    STRINGS.CHARACTERS.WALANI.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "It's a great experience to rest here!"
    STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "I nurtured it meself."
    STRINGS.CHARACTERS.WILBA.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "STRONG TREE CULTIVATED BY WILBA"
    STRINGS.CHARACTERS.WHEELER.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "This is the nice result of taking an adventure."	
	
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.TREENUT = "Something alive inside."
    STRINGS.CHARACTERS.WILLOW.DESCRIBE.TREENUT = "It looks hard to burn, eh."
    STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.TREENUT = "Not very heavy for Wolfgang."
    STRINGS.CHARACTERS.WENDY.DESCRIBE.TREENUT = "It's just adding to my burden."
    STRINGS.CHARACTERS.WX78.DESCRIBE.TREENUT  = "THERE'S A STUPID TREE STUCK INSIDE"
    STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.TREENUT = "I think only dense rainforest is suitable for its growth."
    STRINGS.CHARACTERS.WOODIE.DESCRIBE.TREENUT = "Grow up fast!"
    STRINGS.CHARACTERS.WAXWELL.DESCRIBE.TREENUT = "I'm not interested in it. Had better ignore it."
    STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.TREENUT = "Seedlings of Yggdrasil."
    STRINGS.CHARACTERS.WEBBER.DESCRIBE.TREENUT = "It's almost as big as we are!"
    STRINGS.CHARACTERS.WARLY.DESCRIBE.TREENUT = "It seems inedible."
    STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.TREENUT = "Wants to grow"
    STRINGS.CHARACTERS.WAGSTAFF.DESCRIBE.TREENUT = "It has the potential to become a big tree."
    STRINGS.CHARACTERS.WALANI.DESCRIBE.TREENUT = "That's not an ordinary fruit."
    STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.TREENUT = "What are ye here for?"
    STRINGS.CHARACTERS.WILBA.DESCRIBE.TREENUT = "TOO HEAVY"
    STRINGS.CHARACTERS.WHEELER.DESCRIBE.TREENUT = "Should I pick it up?"	

    STRINGS.CHARACTERS.GENERIC.DESCRIBE.TUBER_POLLEN = "Science says it causes sneezing."
    STRINGS.CHARACTERS.WILLOW.DESCRIBE.TUBER_POLLEN = "It's better to burn it to avoid causing disease."
    STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.TUBER_POLLEN = "A small particle that causes disease."
    STRINGS.CHARACTERS.WENDY.DESCRIBE.TUBER_POLLEN = "It's as bad as a tuber."
    STRINGS.CHARACTERS.WX78.DESCRIBE.TUBER_POLLEN  = "SUBSTANCE CAUSING DISEASE DETECTED"
    STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.TUBER_POLLEN = "It is supposed to be the reproduction mode of tuber trees."
    STRINGS.CHARACTERS.WOODIE.DESCRIBE.TUBER_POLLEN = "Strange substances falling from strange trees."
    STRINGS.CHARACTERS.WAXWELL.DESCRIBE.TUBER_POLLEN = "Stay away!"
    STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.TUBER_POLLEN = "Useless particles."
    STRINGS.CHARACTERS.WEBBER.DESCRIBE.TUBER_POLLEN = "It looks fun."
    STRINGS.CHARACTERS.WARLY.DESCRIBE.TUBER_POLLEN = "It's sticky and not suitable for cooking."
    STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.TUBER_POLLEN = "Baby Tuber"
    STRINGS.CHARACTERS.WAGSTAFF.DESCRIBE.TUBER_POLLEN = "It is better to grow it into a tuber tree than to eat it."
    STRINGS.CHARACTERS.WALANI.DESCRIBE.TUBER_POLLEN = "I usually ignore such things."
    STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.TUBER_POLLEN = "Will it make my wooden leg blossom?"
    STRINGS.CHARACTERS.WILBA.DESCRIBE.TUBER_POLLEN = "TO TUBER OR NOT TO TUBER"
    STRINGS.CHARACTERS.WHEELER.DESCRIBE.TUBER_POLLEN = "I don't think it can be a good projectile."	

    STRINGS.CHARACTERS.GENERIC.DESCRIBE.TUBER_POLLEN_COOKED = "I can still smell it."
    STRINGS.CHARACTERS.WILLOW.DESCRIBE.TUBER_POLLEN_COOKED = "I can burn it again."
    STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.TUBER_POLLEN_COOKED = "Small particles are roasted."
    STRINGS.CHARACTERS.WENDY.DESCRIBE.TUBER_POLLEN_COOKED = "It doesn't even want to change its bad taste."
    STRINGS.CHARACTERS.WX78.DESCRIBE.TUBER_POLLEN_COOKED  = "SCORCH	ATTRIBUTE DETECTED"
    STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.TUBER_POLLEN_COOKED = "It lost its ability to reproduce."
    STRINGS.CHARACTERS.WOODIE.DESCRIBE.TUBER_POLLEN_COOKED = "Shall I make do?"
    STRINGS.CHARACTERS.WAXWELL.DESCRIBE.TUBER_POLLEN_COOKED = "I refuse it."
    STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.TUBER_POLLEN_COOKED = "Was touched by God of Sun."
    STRINGS.CHARACTERS.WEBBER.DESCRIBE.TUBER_POLLEN_COOKED = "Is it still scalding?"
    STRINGS.CHARACTERS.WARLY.DESCRIBE.TUBER_POLLEN_COOKED = "Its essence has not changed."
    STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.TUBER_POLLEN_COOKED = "Burnt"
    STRINGS.CHARACTERS.WAGSTAFF.DESCRIBE.TUBER_POLLEN_COOKED = "I guess it won't grow into a burnt tuber tree."
    STRINGS.CHARACTERS.WALANI.DESCRIBE.TUBER_POLLEN_COOKED = "I can't recover."
    STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.TUBER_POLLEN_COOKED = "Terrible flame!"
    STRINGS.CHARACTERS.WILBA.DESCRIBE.TUBER_POLLEN_COOKED = "BURNT TUBER IS STILL TUBER"
    STRINGS.CHARACTERS.WHEELER.DESCRIBE.TUBER_POLLEN_COOKED = "It experienced a fiery adventure."		
	
elseif GetModConfigData("Language") == false then
    STRINGS.NAMES.TREENUT = "树果"
	STRINGS.NAMES.TREE_PILLAR_ARTIFICIAL = "高出平均值的树干"
	STRINGS.NAMES.TUBER_POLLEN = "块茎颗粒"
	STRINGS.NAMES.TUBER_POLLEN_COOKED = "烧焦的块茎颗粒"
	
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "不科学般地生长。"
    STRINGS.CHARACTERS.WILLOW.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "这够我烧好一阵子的了！"
    STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "是一颗强壮的树。"
    STRINGS.CHARACTERS.WENDY.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "在树荫底下的快乐时光已不复存在......"
    STRINGS.CHARACTERS.WX78.DESCRIBE.TREE_PILLAR_ARTIFICIAL  = "你对我来说很有用，大雨伞"
    STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "很可惜我不能让它达到最初的程度。"
    STRINGS.CHARACTERS.WOODIE.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "足够我砍好一会的了。"
    STRINGS.CHARACTERS.WAXWELL.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "还不够整洁。"
    STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "夜树将守护我们，远离背叛的太阳。"
    STRINGS.CHARACTERS.WEBBER.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "现在我们有了自己的大树！"
    STRINGS.CHARACTERS.WARLY.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "我得确保它结出果实。"
    STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "大大大朋友！"
    STRINGS.CHARACTERS.WAGSTAFF.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "将天气隔档住。"
    STRINGS.CHARACTERS.WALANI.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "在这底下休息可是极佳的体验！"
    STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "是俺自己培育的。"
    STRINGS.CHARACTERS.WILBA.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "薇尔芭培养的强壮树"
    STRINGS.CHARACTERS.WHEELER.DESCRIBE.TREE_PILLAR_ARTIFICIAL = "这就是冒险取得的好成绩。"	
	
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.TREENUT = "里面有活的东西。"
    STRINGS.CHARACTERS.WILLOW.DESCRIBE.TREENUT = "看起来很难燃烧，呃。"
    STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.TREENUT = "对于沃尔夫冈来说不是很重。"
    STRINGS.CHARACTERS.WENDY.DESCRIBE.TREENUT = "它只是在增加我的负担而已。"
    STRINGS.CHARACTERS.WX78.DESCRIBE.TREENUT  = "里面有颗愚蠢的树"
    STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.TREENUT = "我认为只有茂密雨林适合它的生长。"
    STRINGS.CHARACTERS.WOODIE.DESCRIBE.TREENUT = "快快生长吧！"
    STRINGS.CHARACTERS.WAXWELL.DESCRIBE.TREENUT = "我对这不感兴趣，最好还是无视它。"
    STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.TREENUT = "世界树的幼苗！"
    STRINGS.CHARACTERS.WEBBER.DESCRIBE.TREENUT = "它几乎和我们一样大了！"
    STRINGS.CHARACTERS.WARLY.DESCRIBE.TREENUT = "似乎不可食用。"
    STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.TREENUT = "想长大"
    STRINGS.CHARACTERS.WAGSTAFF.DESCRIBE.TREENUT = "有成为大树的潜力。"
    STRINGS.CHARACTERS.WALANI.DESCRIBE.TREENUT = "那可不是什么普通果子。"
    STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.TREENUT = "你是来干什么的？"
    STRINGS.CHARACTERS.WILBA.DESCRIBE.TREENUT = "太重了"
    STRINGS.CHARACTERS.WHEELER.DESCRIBE.TREENUT = "我应该拿起它吗？"	

    STRINGS.CHARACTERS.GENERIC.DESCRIBE.TUBER_POLLEN = "科学说它会引起喷嚏。"
    STRINGS.CHARACTERS.WILLOW.DESCRIBE.TUBER_POLLEN = "不如把它烧了，免得引起疾病。"
    STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.TUBER_POLLEN = "是导致疾病的小颗粒。"
    STRINGS.CHARACTERS.WENDY.DESCRIBE.TUBER_POLLEN = "它和块茎一样糟糕。"
    STRINGS.CHARACTERS.WX78.DESCRIBE.TUBER_POLLEN  = "检测到导致疾病的物质"
    STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.TUBER_POLLEN = "它应该是块茎树的繁殖方式。"
    STRINGS.CHARACTERS.WOODIE.DESCRIBE.TUBER_POLLEN = "奇怪树上掉下来的奇怪物质。"
    STRINGS.CHARACTERS.WAXWELL.DESCRIBE.TUBER_POLLEN = "离远点！"
    STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.TUBER_POLLEN = "无用的颗粒。"
    STRINGS.CHARACTERS.WEBBER.DESCRIBE.TUBER_POLLEN = "看起来很好玩。"
    STRINGS.CHARACTERS.WARLY.DESCRIBE.TUBER_POLLEN = "这东西黏黏的，不适合烹饪。"
    STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.TUBER_POLLEN = "块茎宝宝"
    STRINGS.CHARACTERS.WAGSTAFF.DESCRIBE.TUBER_POLLEN = "与其食用，不如将它培养成块茎树。"
    STRINGS.CHARACTERS.WALANI.DESCRIBE.TUBER_POLLEN = "我通常会无视这种东西。"
    STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.TUBER_POLLEN = "它会使我的木腿开花吗？"
    STRINGS.CHARACTERS.WILBA.DESCRIBE.TUBER_POLLEN = "是块茎否"
    STRINGS.CHARACTERS.WHEELER.DESCRIBE.TUBER_POLLEN = "估计当不了好的弹丸。"	

    STRINGS.CHARACTERS.GENERIC.DESCRIBE.TUBER_POLLEN_COOKED = "我依旧能嗅到那味道。"
    STRINGS.CHARACTERS.WILLOW.DESCRIBE.TUBER_POLLEN_COOKED = "可以再烧一遍。"
    STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.TUBER_POLLEN_COOKED = "小颗粒被烤过了。"
    STRINGS.CHARACTERS.WENDY.DESCRIBE.TUBER_POLLEN_COOKED = "它甚至都不愿意改变它那糟糕的味道。"
    STRINGS.CHARACTERS.WX78.DESCRIBE.TUBER_POLLEN_COOKED  = "检测到烧焦属性"
    STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.TUBER_POLLEN_COOKED = "它失去了繁衍的能力。"
    STRINGS.CHARACTERS.WOODIE.DESCRIBE.TUBER_POLLEN_COOKED = "我要不要勉强凑合？"
    STRINGS.CHARACTERS.WAXWELL.DESCRIBE.TUBER_POLLEN_COOKED = "我拒绝它。"
    STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.TUBER_POLLEN_COOKED = "被太阳神接触过。"
    STRINGS.CHARACTERS.WEBBER.DESCRIBE.TUBER_POLLEN_COOKED = "还很烫吗？"
    STRINGS.CHARACTERS.WARLY.DESCRIBE.TUBER_POLLEN_COOKED = "它的本质还是没有改变。"
    STRINGS.CHARACTERS.WORMWOOD.DESCRIBE.TUBER_POLLEN_COOKED = "烧焦的"
    STRINGS.CHARACTERS.WAGSTAFF.DESCRIBE.TUBER_POLLEN_COOKED = "我猜它不会长成烧焦的块茎树。"
    STRINGS.CHARACTERS.WALANI.DESCRIBE.TUBER_POLLEN_COOKED = "复原不了咯。"
    STRINGS.CHARACTERS.WOODLEGS.DESCRIBE.TUBER_POLLEN_COOKED = "可怕的火焰！"
    STRINGS.CHARACTERS.WILBA.DESCRIBE.TUBER_POLLEN_COOKED = "烧焦的块茎依旧是块茎"
    STRINGS.CHARACTERS.WHEELER.DESCRIBE.TUBER_POLLEN_COOKED = "它经历了一次炽热的冒险。"		
	
end

AddPrefabPostInit("fireflies", function(inst)
    inst:AddTag("firefly")
end)

AddPrefabPostInit("lotus", function(inst)
    inst:AddTag("lotus")
end)

AddPrefabPostInit("reeds_water", function(inst)
    inst:AddTag("water_reeds")
end)

AddPrefabPostInit("dug_nettle", function(inst)
    inst:AddTag("dug_nettle")
end)

local function addtagofnoblock(inst)
    if not inst:HasTag("NOBLOCK") then
	    inst:AddTag("NOBLOCK")
	end
end

AddPrefabPostInit("jungle_border_vine", addtagofnoblock)
AddPrefabPostInit("hanging_vine", addtagofnoblock)
AddPrefabPostInit("grabbing_vine", addtagofnoblock)

local function addtagcanopymob(inst)
    inst:AddTag("canopymob")
end

AddPrefabPostInit("mean_flytrap", addtagcanopymob)
AddPrefabPostInit("adult_flytrap", addtagcanopymob)
AddPrefabPostInit("grabbing_vine", addtagcanopymob)
AddPrefabPostInit("spider_monkey", addtagcanopymob)
AddPrefabPostInit("rabid_beetle", addtagcanopymob)
AddPrefabPostInit("snake_amphibious", addtagcanopymob)
AddPrefabPostInit("scorpion", addtagcanopymob)

local function IsOnCanopyEdge(inst)
    local x, y, z = inst.Transform:GetWorldPosition()
    local radius = 1.5

    if GetWorld().Map:GetTileAtPoint(x, y, z) ~= GROUND.IMPASSABLE then
        return false
    end
	
    for i = -radius, radius, 1 do
        if GetWorld().Map:GetTileAtPoint(x - radius, y, z + i) == GROUND.DEEPRAINFOREST 
		    or GetWorld().Map:GetTileAtPoint(x + radius, y, z + i) == GROUND.DEEPRAINFOREST 
			or GetWorld().Map:GetTileAtPoint(x - radius, y, z + i) == GROUND.GASJUNGLE
			or GetWorld().Map:GetTileAtPoint(x + radius, y, z + i) == GROUND.GASJUNGLE 
		then
            return true
        end
    end
	
    for i = -(radius - 1), radius - 1, 1 do
        if GetWorld().Map:GetTileAtPoint(x + i, y, z - radius) == GROUND.DEEPRAINFOREST 
		    or GetWorld().Map:GetTileAtPoint(x + i, y, z + radius) == GROUND.DEEPRAINFOREST 
			or GetWorld().Map:GetTileAtPoint(x + i, y, z - radius) == GROUND.GASJUNGLE
			or GetWorld().Map:GetTileAtPoint(x + i, y, z + radius) == GROUND.GASJUNGLE 
		then
            return true
        end
    end
	
    return false

end


AddClassPostConstruct("screens/playerhud", function(self)

local _UpdateLeaves = self.UpdateLeaves
function self:UpdateLeaves(dt)
    --_UpdateLeaves(self, dt)

	local wasup = false
	if self.leavestop_intensity and self.leavestop_intensity > 0 then
		wasup = true
	end

	if not self.leavestopmultiplytarget then
		self.leavestopmultiplytarget = {r=1, g=1, b=1}
		self.leavestopmultiplycurrent = {r=1, g=1, b=1}		
	end

	if GetClock and GetClock() and GetClock():IsDusk() then
		self:SetLeavesTopColorMult(0.6, 0.6, 0.6)		
	elseif  GetClock and GetClock() and GetClock():IsNight() then
		self:SetLeavesTopColorMult(0.1, 0.1, 0.1)
	else
		self:SetLeavesTopColorMult(1, 1, 1)
	end	

	if self.leavesTop then
		if self.leavestopmultiplycurrent ~= self.leavestopmultiplytarget then
			if self.leavestopmultiplycurrent.r > self.leavestopmultiplytarget.r then
				self.leavestopmultiplycurrent.r = math.max(self.leavestopmultiplytarget.r, self.leavestopmultiplycurrent.r - (1*dt) )
				self.leavestopmultiplycurrent.g = math.max(self.leavestopmultiplytarget.g, self.leavestopmultiplycurrent.g - (1*dt) )
				self.leavestopmultiplycurrent.b = math.max(self.leavestopmultiplytarget.b, self.leavestopmultiplycurrent.b - (1*dt) )			
			else
				self.leavestopmultiplycurrent.r = math.min(self.leavestopmultiplytarget.r, self.leavestopmultiplycurrent.r + (1*dt) )
				self.leavestopmultiplycurrent.g = math.min(self.leavestopmultiplytarget.g, self.leavestopmultiplycurrent.g + (1*dt) )
				self.leavestopmultiplycurrent.b = math.min(self.leavestopmultiplytarget.b, self.leavestopmultiplycurrent.b + (1*dt) )
			end
			self.leavesTop:GetAnimState():SetMultColour(self.leavestopmultiplycurrent.r,self.leavestopmultiplycurrent.g,self.leavestopmultiplycurrent.b,1)
		end
		
	    if not self.leavestop_intensity then
	    	self.leavestop_intensity = 0
	    end	 

	    local player = GetPlayer()	  
	    self.under_leaves = false 

	    local pos = GetPlayer():GetPosition()
	    local ground = GetWorld()
	    local tile = ground.Map:GetTileAtPoint(pos.x, 0, pos.z)
	    for i,tiletype in ipairs(IS_CANOPY_TILE)do
	    	if tiletype == tile then
	    		self.under_leaves = true
	    	end
	    end
		
		if IsOnCanopyEdge(GetPlayer()) then
		    self.under_leaves = true
		end

		local x, y, z = GetPlayer().Transform:GetWorldPosition()		
        local canopy = TheSim:FindEntities(x,y,z, TUNING.SHADE_CANOPY_RANGE_SMALL, {"shadecanopysmall"})
        if #canopy > 0 then
		    self.under_leaves = true 
        end		

	 	if self.under_leaves then
			self.leavestop_intensity = math.min(1,self.leavestop_intensity+(1/30) )
		else			
		 	self.leavestop_intensity = math.max(0,self.leavestop_intensity-(1/30) )
		end	

	    if self.leavestop_intensity == 0 then
	    	if wasup then
	    		GetPlayer():PushEvent("canopyout")
	    	end

	    	self.leavesTop:Hide()
	    else
	    	self.leavesTop:Show()

			if self.leavestop_intensity == 1 then
		    	if not self.leavesfullyin then
		    		self.leavesTop:GetAnimState():PlayAnimation("idle", true)	
		    		self.leavesfullyin = true
		    		GetPlayer():PushEvent("canopyin")
		    	else	
			    	if GetPlayer().sg:HasStateTag("moving") then
			    		if not self.leavesmoving then
			    			self.leavesmoving = true
			    			self.leavesTop:GetAnimState():PlayAnimation("run_pre")	
			    			self.leavesTop:GetAnimState():PushAnimation("run_loop", true)					    					    	
			    		end
			    	else
			    		if self.leavesmoving then
			    			self.leavesmoving = nil
			    			self.leavesTop:GetAnimState():PlayAnimation("run_pst")	
			    			self.leavesTop:GetAnimState():PushAnimation("idle", true)	
			    			self.leaves_olddir = nil
			    		end
			    	end
		    	end
		    else
		    	self.leavesfullyin = nil
		    	self.leavesmoving = nil
		    	self.leavesTop:GetAnimState():SetPercent("zoom_in", self.leavestop_intensity)
			end	    	
	    end	    	    	
    end
	
end

end)


AddComponentPostInit("moisture", function(self)

local _CheckForShelter = self.CheckForShelter 
function self:CheckForShelter()
    _CheckForShelter(self)
	local x, y, z = self.inst.Transform:GetWorldPosition()
	local SHELTERED_SHADE = .6
    local canopy = TheSim:FindEntities(x,y,z, TUNING.SHADE_CANOPY_RANGE_SMALL, {"shadecanopysmall"})
    if #canopy > 0 then
		self.sheltered = true
		self.targetshade = SHELTERED_SHADE
		self.inst:PushEvent("sheltered")   
    end	
end

end)


AddComponentPostInit("temperature", function(self)

--local _OnUpdate = self.OnUpdate 
function self:OnUpdate(dt, applyhealthdelta)
    --_OnUpdate(self, dt, applyhealthdelta)
	if self.settemp then return end

	if applyhealthdelta == nil then
		applyhealthdelta = true
	end
	
	if (self.inst.components.health and self.inst.components.health.invincible == true) or self.inst.is_teleporting == true then
		return
	end

    local last = self.current

    local seasonmgr = GetSeasonManager()
	local ambient_delta = ((seasonmgr and seasonmgr:GetCurrentTemperature() or TUNING.STARTING_TEMP) - self.current) or 0

	ambient_delta = ambient_delta - self:GetMoisturePenalty()

	if seasonmgr and self.inst.components.inventory then
		for k,v in pairs (self.inst.components.inventory.equipslots) do
			if v.components.heater then
				local heat = v.components.heater:GetEquippedHeat(self.inst)
				if v.components.heater.show_heat then
					v:PushEvent("get_heat")
				end
				if heat ~= nil and heat > self.current then
					ambient_delta = ambient_delta + (heat - self.current)
				elseif heat ~= nil and heat < self.current then
					ambient_delta = ambient_delta - (self.current - heat)
				end
			end
		end
		for k,v in pairs(self.inst.components.inventory.itemslots) do
			if v.components.heater then
				local carrieddelta = v.components.heater:GetCarriedHeat()
				if v.components.heater.show_heat then
					v:PushEvent("get_heat")
				end
				if carrieddelta ~= nil then
					ambient_delta = ambient_delta + carrieddelta
				end
			end
		end
		if self.inst.components.inventory.overflow and self.inst.components.inventory.overflow.components.container then
			for k,v in pairs(self.inst.components.inventory.overflow.components.container.slots) do
				if v.components.heater then
					local carrieddelta = v.components.heater:GetCarriedHeat()
					if v.components.heater.show_heat then
						v:PushEvent("get_heat")
					end
					if carrieddelta ~= nil then
						ambient_delta = ambient_delta + carrieddelta
					end
				end
			end
		end
		-- Recently eaten temperatured food is inherently equipped heat/cold
		if self.inst.recent_temperatured_food and self.inst.recent_temperatured_food ~= 0 then
			ambient_delta = ambient_delta + self.inst.recent_temperatured_food
		end
	end

	-- If very hot (basically only when have overheating screen effect showing) and under shelter, cool slightly
 	local x, y, z = self.inst.Transform:GetWorldPosition()
    local canopy = TheSim:FindEntities(x,y,z, TUNING.SHADE_CANOPY_RANGE_SMALL, {"shadecanopysmall"})

    if self.current > TUNING.TREE_SHADE_COOLING_THRESHOLD then
	    if self.sheltered and #canopy <= 0 then
		    ambient_delta = ambient_delta - (self.current - TUNING.TREE_SHADE_COOLER)
		elseif #canopy > 0 then
		    ambient_delta = ambient_delta - (self.current - TUNING.TREE_SHADE_COOLER/2)
		end
	end

	--now figure out the temperature where we are standing
	local x,y,z = self.inst.Transform:GetWorldPosition()
	
	local ZERO_DISTANCE = 10
	local ZERO_DISTSQ = ZERO_DISTANCE*ZERO_DISTANCE

	local ents = TheSim:FindEntities(x,y,z, ZERO_DISTANCE, {"HASHEATER"})
	local area_heat = 0
	local num_area_heat_sources = 0
    for k,v in pairs(ents) do 
		if v.components.heater and v ~= self.inst and not v:IsInLimbo() then
			local heat = v.components.heater:GetHeat(self.inst)
			if v.components.heater.show_heat then
				v:PushEvent("get_heat")
			end
			local distsq = self.inst:GetDistanceSqToInst(v)

			-- This produces a gentle falloff from 1 to zero.
			local heatfactor = ((-1/ZERO_DISTSQ)*distsq) + 1
			local mm = GetWorld().components.moisturemanager
	        if mm and ((not mm:IsEntityDry(self.inst)) or (mm:IsWorldWet() and not GetPlayer().components.inventory:IsWaterproof())) then
	            heatfactor = heatfactor * TUNING.WET_HEAT_FACTOR_PENALTY
	        end

			if heat*heatfactor > self.current then
				if heat > 0 then
					area_heat = area_heat + (heat*heatfactor - self.current)
					num_area_heat_sources = num_area_heat_sources + 1
				end
			elseif heat*heatfactor < self.current then
				if heat < 0 then
					area_heat = area_heat - (self.current - heat*heatfactor)
					num_area_heat_sources = num_area_heat_sources + 1
				end
			end
		end
    end	
    if num_area_heat_sources > 0 then
    	ambient_delta = ambient_delta + (area_heat / num_area_heat_sources)
    end

	-- Volcano adds heat
	local lava_dist = math.huge
    if GetWorld().IsVolcano() then
		if GetWorld().components.volcanomanager:IsErupting() then
			ambient_delta = ambient_delta + TUNING.VOLCANORIM_ACTIVE_HEAT
		else
	    	local map = GetWorld().Map
	    	if map and map:IsTileGridValid() then
				local tx, ty = map:GetTileXYAtPoint(x, y, z)
				lava_dist = map:GetClosestTileDist(tx, ty, GROUND.VOLCANO_LAVA, TUNING.VOLCANORIM_LAVA_DIST)
				if lava_dist <= TUNING.VOLCANORIM_LAVA_DIST then
					ambient_delta = ambient_delta + TUNING.VOLCANORIM_LAVA_HEAT
				end
			end
		end
    end
	
	local winterInsulation, summerInsulation = self:GetInsulation()

	local delta = ambient_delta
	self.last_real_delta = delta
	local freezeTime = TUNING.SEG_TIME + winterInsulation
	local overheatTime = TUNING.SEG_TIME + summerInsulation 
	-- local freeze_or_overheat_time = TUNING.SEG_TIME + total_insulation

	if seasonmgr then
		if self:IsCooling() and self:IsCool() then
			if seasonmgr:GetCurrentTemperature() >= TUNING.STARTING_TEMP then --cooling down, obj is cold, world is hot
				self.rate = math.max(delta, -TUNING.WARM_DEGREES_PER_SEC)
			else --cooling down, obj is cold, world is cold
				self.rate = math.max(delta, -TUNING.SEG_TIME / freezeTime) 
			end
		elseif self:IsWarming() and self:IsCool() then 
			if seasonmgr:GetCurrentTemperature() >= TUNING.STARTING_TEMP then --warming up, obj is cold and world is hot
				self.rate = math.min(delta, TUNING.SEG_TIME / overheatTime)
			else --warming up, obj is cold and world is cold
				self.rate = math.min(delta, self.current <= 0 and TUNING.THAW_DEGREES_PER_SEC or TUNING.WARM_DEGREES_PER_SEC)
			end
		elseif self:IsCooling() and self:IsWarm() then
			if seasonmgr:GetCurrentTemperature() >= TUNING.STARTING_TEMP then --cooling down, obj is warm and world is hot
				self.rate = math.max(delta, self.current >= self.overheattemp and -TUNING.THAW_DEGREES_PER_SEC or -TUNING.WARM_DEGREES_PER_SEC)
			else --cooling down, obj is warm and world is cold
				self.rate = math.max(delta, -TUNING.SEG_TIME / freezeTime)
			end
		elseif self:IsWarming() and self:IsWarm() then
			if seasonmgr:GetCurrentTemperature() >= TUNING.STARTING_TEMP then --warming up, obj is warm, world is hot
				self.rate = math.min(delta, TUNING.SEG_TIME / overheatTime)
			else --warming up, obj is warm, world is cold
				self.rate = math.min(delta, TUNING.WARM_DEGREES_PER_SEC)
			end
		else
			self.rate = 0
		end
	end

	if self.inst.components.inventoryitem and 
		self.inst.components.inventoryitem.owner and 
		self.inst.components.inventoryitem.owner:HasTag("fridge") and not
		self.inst.components.inventoryitem.owner:HasTag("nocool") and --For icepack.
		self.current > 0 then -- Don't cool it below freezing
		self.rate = -TUNING.WARM_DEGREES_PER_SEC
		if self.inst.components.inventoryitem.owner:HasTag("lowcool") then
			self.rate = self.rate * .5
		end
	end

    if GetWorld().IsVolcano() then
		if GetWorld().components.volcanomanager:IsErupting() then
			self.rate = TUNING.VOLCANORIM_ACTIVE_MULT * self.rate
		elseif lava_dist <= TUNING.VOLCANORIM_LAVA_DIST then
			self.rate = TUNING.VOLCANORIM_LAVA_MULT * (1 - (lava_dist / TUNING.VOLCANORIM_LAVA_DIST)) * self.rate
		end
    end
		
	-- --Always get "slowest" rate. Max when cooling, Min when warming.
	-- if delta < 0 and self.current < TUNING.STARTING_TEMP then
	-- 	self.rate = math.max(delta, -TUNING.SEG_TIME / freeze_or_overheat_time)
	-- elseif delta > 0 and self.current < TUNING.STARTING_TEMP then	
	-- 	self.rate = math.min(delta, self.current <= 0 and TUNING.THAW_DEGREES_PER_SEC or TUNING.WARM_DEGREES_PER_SEC)
	-- elseif delta < 0 and self.current >= TUNING.STARTING_TEMP then
	-- 	self.rate = math.max(delta, self.current <= self.overheattemp and -TUNING.THAW_DEGREES_PER_SEC or -TUNING.WARM_DEGREES_PER_SEC)
	-- elseif delta > 0 and self.current >= TUNING.STARTING_TEMP then	
	-- 	self.rate = math.min(delta, TUNING.SEG_TIME / freeze_or_overheat_time)
	-- else
	-- 	self.rate = 0
	-- end
		
    self.current = math.max( math.min( self.current + self.rate*dt, self.maxtemp), self.mintemp)
	
    if (self.current < 0) ~= (last < 0)  then
    	if self.current < 0 then
    		self.inst:PushEvent("startfreezing")
    	else
    		self.inst:PushEvent("stopfreezing")
    	end
    end

    if (self.current > self.overheattemp) ~= (last > self.overheattemp) then
    	if self.current > self.overheattemp then
    		self.inst:PushEvent("startoverheating")
    	else
    		self.inst:PushEvent("stopoverheating")
    	end
    end

	self.inst:PushEvent("temperaturedelta")
	
	if applyhealthdelta and self.current < 0 and self.inst.components.health then
		self.inst.components.health:DoDelta(-self.hurtrate*dt, true, "cold") 
	elseif applyhealthdelta and self.current > self.overheattemp and self.inst.components.health then
		self.inst.components.health:DoDelta(-self.hurtrate*dt, true, "hot") 
	end
	
end

end)


AddComponentPostInit("seasonmanager", function(self)

local _CheckValidWildfireStarter = self.CheckValidWildfireStarter 
function self:CheckValidWildfireStarter(obj)
    --_CheckValidWildfireStarter(self, obj)
	if obj and obj:IsValid() and obj.components.burnable and not obj:HasTag("fireimmune") then
	
		if obj.Transform ~= nil then
	        local x, y, z = obj.Transform:GetWorldPosition()
            local canopy = TheSim:FindEntities(x,y,z, TUNING.SHADE_CANOPY_RANGE_SMALL, {"shadecanopysmall"})
            if #canopy > 0 then
                return false --Item under canopy
            end						        
		end	
	
		if obj.components.inventoryitem and obj.components.inventoryitem.owner then
			return false --Item in player's inventory
		end
		if not obj.components.pickable and not obj.components.crop and not obj.components.growable then
			return true --Non-plant
		end
		if obj.components.pickable and obj.components.pickable:IsWildfireStarter() then
			return true --Wild plants
		end
		if obj.components.crop and obj.components.crop:IsWithered() then
			return true --Farm/crop plant
		end
		if obj.components.workable and obj.components.workable:GetWorkAction() == ACTIONS.CHOP then
			return true --Tree
		end
	end
	return false
end


local _DoLightningStrike = self.DoLightningStrike
function self:DoLightningStrike(pos, ignoreRods, targetinst)
    --_DoLightningStrike(self, pos, ignoreRods, targetinst)
    local tiletype = GetGroundTypeAtPosition(GetPlayer():GetPosition())
    local IsCanopyTile = tiletype == GROUND.DEEPRAINFOREST or tiletype == GROUND.GASJUNGLE
	local x, y, z = GetPlayer().Transform:GetWorldPosition()
    local canopy = TheSim:FindEntities(x,y,z, TUNING.SHADE_CANOPY_RANGE_SMALL, {"shadecanopysmall"})
	if not self.ininterior and not IsCanopyTile and #canopy <= 0 then
		local player = GetPlayer()
		targetinst = targetinst or player

	    local rod = nil
		local target = nil

		-- Check if we should hit the player
	    if targetinst == player then
		    if player.components.playerlightningtarget 
            and math.random() <= player.components.playerlightningtarget:GetHitChance() then
	    	    target = player
				pos = Vector3(target.Transform:GetWorldPosition() ) 
            end
		else
		    -- targeting something else
	        if math.random() <= TUNING.LIGHTING_HITTARGET_CHANCE then
				target = targetinst
				pos = Vector3(target.Transform:GetWorldPosition() ) 
            end
	    end
		-- now check if there's a rod nearby
		if not ignoreRods then
		    local rods = TheSim:FindEntities(pos.x, pos.y, pos.z, 40, {"lightningrod"}, {"dead"})
		    for k,v in pairs(rods) do -- Find nearby lightning rods, prioritize battery-charging rods and closer rods
		    	print(v.prefab)
		        if not rod or (v.lightningpriority > rod.lightningpriority or distsq(pos, Vector3(v.Transform:GetWorldPosition())) < distsq(pos, Vector3(rod.Transform:GetWorldPosition()))) then
		            rod = v
		        end
		    end
		    if rod then
		        target = rod
				pos = Vector3(target.Transform:GetWorldPosition() ) 
		    end
		end

		local lightning = SpawnPrefab("lightning")
		lightning.Transform:SetPosition(pos:Get())

	    if rod then
	        rod:PushEvent("lightningstrike", {rod=rod})
	    else
	        if target and target.components.playerlightningtarget then
	        	player.components.playerlightningtarget:DoStrike()
	        end

	        local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 3, nil, {"FX", "NOCLICK", "DECOR", "INLIMBO"})
	        for k,v in pairs(ents) do 
			    if not v:IsInLimbo() then
					local protected = false
        			if v.components.inventory and v.components.inventory:IsInsulated() then
            			protected = true
        			end
					
 				    local tiletype = GetGroundTypeAtPosition(v:GetPosition())
				    if tiletype == GROUND.DEEPRAINFOREST or tiletype == GROUND.GASJUNGLE then
				        protected = true
				    end
					
					if v.Transform ~= nil then
	                    local x, y, z = v.Transform:GetWorldPosition()
                        local canopy = TheSim:FindEntities(x,y,z, TUNING.SHADE_CANOPY_RANGE_SMALL, {"shadecanopysmall"})
                        if #canopy > 0 then
                            protected = true
                        end								
					end

			        if not protected and v.components.burnable and not v.components.fueled and not v.components.burnable.lightningimmune then
		        	    v.components.burnable:Ignite()
		    	    end
		        end
	        end
	    end

    elseif IsCanopyTile or #canopy > 0 then
		local theta = math.random(0, 2*PI)
		local radius = 10
		local pos = Vector3(GetPlayer().Transform:GetWorldPosition()) +  Vector3(radius * math.cos( theta ), 0, radius * math.sin( theta ))
		local soundplayer = SpawnPrefab("soundplayer")
		soundplayer.PlaySound(pos, "dontstarve/rain/thunder_close")
		GetPlayer().components.playercontroller:ShakeCamera(GetPlayer(), "VERTICAL", 2.8, 0.025, 0.3, 40)
		for i=1, math.random(3,5) do
            local x, _, z = GetPlayer().Transform:GetWorldPosition()
            local canopy_resources = {"cutgrass", "twigs", "foliage"}
            local item = SpawnPrefab(GetRandomItem(canopy_resources))
            local dist = 6 + 10 * math.random()
            local subtheta = math.random() * 2 * PI
            local spawn_x, spawn_z
            spawn_x, spawn_z = x + math.cos(subtheta) * dist, z + math.sin(subtheta) * dist	    	
            item.Transform:SetPosition(spawn_x, 10, spawn_z)


			item:DoTaskInTime(1, function() --Improve this
			    if not item:IsOnValidGround() then
				    local x, y, z = item.Transform:GetWorldPosition()
				    SpawnPrefab("splash_clouds_drop").Transform:SetPosition(x, y, z)
				    item:Remove()			    
			    elseif item:GetIsOnWater() then
			        if item.components.floatable ~= nil then
				        item.components.floatable:OnHitWater()
				    else
				        local x, y, z = item.Transform:GetWorldPosition()
				        SpawnPrefab("splash_water_sink").Transform:SetPosition(x, y, z)
					    item:Remove()
				    end
			    end
			end)
        end
	else
		-- INDOORS, So just make a big boom outside.
		local theta = math.random(0, 2*PI)
		local radius = 10
		local pos = Vector3(GetPlayer().Transform:GetWorldPosition()) +  Vector3(radius * math.cos( theta ), 0, radius * math.sin( theta ))
		local soundplayer = SpawnPrefab("soundplayer")
		soundplayer.PlaySound(pos, "dontstarve/rain/thunder_close")
	end	
	
end

end)


local function _isWaterOrImpassable(map, tile)
	return map:IsWater(tile) or tile == GROUND.IMPASSABLE
end

local function _IsPointCloseToWaterOrImpassable(x, y, z, radius)
    local map = GetWorld().Map
    
    for i = -radius, radius, 1 do
        if _isWaterOrImpassable(map, map:GetTileAtPoint(x - radius, y, z + i)) or _isWaterOrImpassable(map, map:GetTileAtPoint(x + radius, y, z + i)) then
            return true
        end
    end

    for i = -(radius - 1), radius - 1, 1 do
        if _isWaterOrImpassable(map, map:GetTileAtPoint(x + i, y, z - radius)) or _isWaterOrImpassable(map, map:GetTileAtPoint(x + i, y, z + radius)) then
            return true
        end
    end

    return false
end

AddComponentPostInit("roccontroller", function(self)

local SCREEN_DIST = 50
local HEAD_ATTACK_DIST = 0.1 -- 1.5
local SCALERATE = 1/(30 *2)  -- 2 seconds to go from 0 to 1

local HEADDIST = 17
local HEADDIST_TARGET = 15
local BODY_DIST_TOLLERANCE = 2

local TAILDIST = 13

local LEGDIST = TUNING.ROC_LEGDSIT
local LEG_WALKDIST = 4
local LEG_WALKDIST_BIG = 6
local LAND_PROX = 15 --7

local _GetTarget = self.GetTarget
function self:GetTarget()
    --_GetTarget(self)
	if not self.target or not self.target:IsValid() or self.target == GetPlayer() then		
		-- look for items.. 
		local pos = Vector3(self.inst.Transform:GetWorldPosition())
		local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 20, {"structure"})
		for i=#ents,1, -1 do
			if not ents[i].components.workable then			
				table.remove(ents,i)
			end
		end

		local sorted = {}
		if #ents > 0 then
			for i, ent in ipairs(ents)do
				if ent then
					local x,y,z = ent.Transform:GetWorldPosition()
					local ground = GetWorld()
						
					local tile = ground.Map:GetTileAtPoint(x, y, z)
					local canopy = TheSim:FindEntities(x,y,z, TUNING.SHADE_CANOPY_RANGE_SMALL, {"shadecanopysmall"})

					if tile ~= GROUND.FOUNDATION 
					   and tile ~= GROUND.COBBLEROAD 
					   and tile ~= GROUND.LAWN 
					   and tile ~= GROUND.LILYPOND 
					   and tile ~= GROUND.DEEPRAINFOREST 
					   and tile ~= GROUND.GASJUNGLE 
					   and #canopy <= 0 then
						table.insert(sorted, {ent, ent:GetDistanceSqToInst(self.head)})
					end
				end
			end
			if #sorted > 0 then
				table.sort( sorted, function( a, b ) return a[2] > b[2] end )				
				self.target = sorted[#sorted][1]
			end
		end		
		-- look for structures..
		-- look for player		
	end

	if self.target and self.target:IsValid() then
		return self.target
	end

	self.target = GetPlayer()
	return GetPlayer()

end

local _OnUpdate = self.OnUpdate
function self:OnUpdate(dt)
    --_OnUpdate(self, dt)
	local function getanglepointtopoint(x1,z1,x2,z2)			    
	    local dz = z1 - z2
	    local dx = x2 - x1
	    local angle = math.atan2(dz, dx) / DEGREES
	    return angle				
	end	

	local player = GetPlayer()
	local px,py,pz = player.Transform:GetWorldPosition()
	
	local ground = GetWorld()
	local tile = GetVisualTileType(px, py, pz)
	local onvalidtiles = true
	if tile == GROUND.FOUNDATION 
	    or tile == GROUND.COBBLEROAD 
		or tile == GROUND.LAWN 
		or tile == GROUND.LILYPOND 
		or tile == GROUND.DEEPRAINFOREST 
		or tile == GROUND.GASJUNGLE then  --  tile == GROUND.FIELDS or
		onvalidtiles = false
	end
	
	local canopy = TheSim:FindEntities(px,py,pz, TUNING.SHADE_CANOPY_RANGE_SMALL, {"shadecanopysmall"})
	if #canopy > 0 then
	    onvalidtiles = false
	end

	if player.sg:HasStateTag("scary_to_predator") then
		onvalidtiles = false
	end

	-- Roc doesnt like the living artifact.
	if player.livingartifact then
		onvalidtiles = false
	end

	if TheCamera.interior then
		onvalidtiles = false
	end
	
	if _IsPointCloseToWaterOrImpassable(px, py, pz, 8) then
	    onvalidtiles = false
	end

	local onvaliddungtiles = false	

	local cx,cy,cz = self.inst.Transform:GetWorldPosition()
	local roctile = ground.Map:GetTileAtPoint(cx,cy,cz)
	local undercanopy = TheSim:FindEntities(cx,cy,cz, TUNING.SHADE_CANOPY_RANGE_SMALL, {"shadecanopysmall"})

	if (roctile == GROUND.RAINFOREST or roctile == GROUND.PLAINS) and #undercanopy <= 0 then	 
		onvaliddungtiles = true
	end


	local disttoplayer = self.inst:GetDistanceSqToInst(player)
	if disttoplayer > SCREEN_DIST*SCREEN_DIST then
		-- has landed and is flying again, should leave now
		if self.liftoff and not self.inst.teleporting then
			print("FLY AWAY")
			self.inst:Remove()
		elseif not self.landed then			
			self.inst.Transform:SetRotation(self.inst:GetAngleToPoint(px, py, pz))
		end
	end

	if self.scaleup then
		local currentscale = self.inst.Transform:GetScale()
		if currentscale ~= self.scaleup.targetscale then
			local setscale = math.min( currentscale + (SCALERATE*dt), self.scaleup.targetscale )
			self:setscale(setscale)			
		else 
			self.scaleup = nil
		end
	end

	if self.inst.Transform:GetScale() == 1 and not self.landed and not self.liftoff then					
		if disttoplayer < LAND_PROX*LAND_PROX and onvalidtiles then
			self.landed = true
			self.inst:PushEvent("land")
		end			
	end

	local dungok = true
	if GetWorld().getworldgenoptions(GetWorld())["dungpile"] then
		if GetWorld().getworldgenoptions(GetWorld())["dungpile"] == "never" then
			dungok = false
		end
	end

	if not self.landed and onvaliddungtiles and dungok then				

		if self.dungtime > 0 then
			self.dungtime = math.max(self.dungtime - dt,0)
		else
			local pos = Vector3(self.inst.Transform:GetWorldPosition())
			local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 50, {"dungpile"})
			if #ents < 2 then
				
				self.inst:DoTaskInTime(1 + Remap(self.inst.Transform:GetScale(), 0.35, 1,2,0), function()
					local crap = SpawnPrefab("dungpile")
					crap.Transform:SetPosition(cx,cy,cz)
					crap.fall(crap)
				end)
			end
			self.dungtime = math.random()*10 + 2
		end		
	end

	if not self.busy then
		if self.landed and self.head and self.tail and self.leg1 and self.leg2 then
			if onvalidtiles and not GetClock():IsNight() and not player.components.health:IsDead() then

				local target = self:GetTarget()
				
				-- HEAD
				if not self.head.sg:HasStateTag("busy") then
					local targetpos =Vector3(target.Transform:GetWorldPosition())	
					local headdistsq = self.head:GetDistanceSqToInst(target) 
					if headdistsq > HEAD_ATTACK_DIST*HEAD_ATTACK_DIST then			
						self.head_vel = math.min(self.head_vel + (self.head_acc *dt), self.head_vel_max)
					else					
						if self.target:HasTag("isinventoryitem") or self.target == GetPlayer() then							
							if self.target == GetPlayer() and not self.target.sg:HasStateTag("cower") then
								GetPlayer():PushEvent("cower")
							end																
							if headdistsq < 0.2 then
								self.head:PushEvent("gobble")				
							end
						else
							self.head:PushEvent("bash")				
						end
						self.head_vel = math.max(self.head_vel - (self.head_acc *dt), 0)
					end
					local HEAD_VEL = self.head_vel *dt

					local angle = self.head:GetAngleToPoint(targetpos)*DEGREES
					local offset = Vector3(HEAD_VEL * math.cos( angle ), 0, -HEAD_VEL * math.sin( angle ))
					local pos = Vector3(self.head.Transform:GetWorldPosition())
					self.head.Transform:SetPosition(pos.x+offset.x,0,pos.z+offset.z)
				end

				-- BODY
				local bodistsq = self.inst:GetDistanceSqToInst(self.head) 
				local pos = Vector3(self.inst.Transform:GetWorldPosition())
				
				local BOD_VEL_MAX = self.speed
				local BOD_ACC_MAX = 0.5 --5
				local targetpos = Vector3(self.head.Transform:GetWorldPosition())
				local angle = self.head:GetAngleToPoint(pos)*DEGREES
				local offset = Vector3(1 * math.cos( angle ), 0, -1 * math.sin( angle ))
				offset.x = offset.x*HEADDIST_TARGET
				offset.z = offset.z*HEADDIST_TARGET
				targetpos = targetpos + Vector3(offset.x,0,offset.z)

				local bodistsq = self.inst:GetDistanceSqToPoint(targetpos) 

				if bodistsq > BODY_DIST_TOLLERANCE * BODY_DIST_TOLLERANCE then
					local cpbv = pos + Vector3(self.body_vel.x,0,self.body_vel.z)
					local angle = getanglepointtopoint(cpbv.x,cpbv.z,targetpos.x,targetpos.z)*DEGREES			
					local offset = Vector3(BOD_ACC_MAX * math.cos( angle ), 0, -BOD_ACC_MAX * math.sin( angle ))			
					local cpbvtv = cpbv + Vector3(offset.x,0,offset.z)
					local finalangle = self.inst:GetAngleToPoint(cpbvtv)*DEGREES
					local finalvel = math.min(BOD_VEL_MAX, math.sqrt(self.inst:GetDistanceSqToPoint(cpbvtv))    )
					self.body_vel = Vector3(finalvel * math.cos( finalangle ), 0, -finalvel * math.sin( finalangle ))
				else

					local angle = self.inst:GetAngleToPoint(targetpos)*DEGREES			
					local vel = math.max( math.sqrt((self.body_vel.x * self.body_vel.x) + (self.body_vel.z * self.body_vel.z)) - (BOD_ACC_MAX*dt) , 0)
					self.body_vel = Vector3(vel * math.cos( angle ), 0, -vel * math.sin( angle ))
				end
				self.inst.Transform:SetPosition(pos.x+(self.body_vel.x * dt),0,pos.z+(self.body_vel.z *dt)	)

				--TAIL
				local angle = (self.inst.Transform:GetRotation()*DEGREES) + PI
				local tailtarget =  Vector3(TAILDIST * math.cos( angle ), 0, -TAILDIST * math.sin( angle ))
				tailtarget =Vector3(self.inst.Transform:GetWorldPosition()) + tailtarget
				local taildistsq = self.tail:GetDistanceSqToPoint(tailtarget)
				local pos = Vector3(self.tail.Transform:GetWorldPosition())
				local TAIL_VEL_MAX = self.speed 
				local TAIL_ACC_MAX = 0.3 --5

				if taildistsq > 1 * 1 then
					local cpbv = pos + Vector3(self.tail_vel.x,0,self.tail_vel.z)
					local angle = getanglepointtopoint(cpbv.x,cpbv.z,tailtarget.x,tailtarget.z)*DEGREES			
					local offset = Vector3(TAIL_ACC_MAX * math.cos( angle ), 0, -TAIL_ACC_MAX * math.sin( angle ))			
					local cpbvtv = cpbv + Vector3(offset.x,0,offset.z)
					local finalangle = self.tail:GetAngleToPoint(cpbvtv)*DEGREES
					local finalvel = math.min(TAIL_VEL_MAX, math.sqrt(self.tail:GetDistanceSqToPoint(cpbvtv))    )
					self.tail_vel = Vector3(finalvel * math.cos( finalangle ), 0, -finalvel * math.sin( finalangle ))
				else

					local angle = self.tail:GetAngleToPoint(tailtarget)*DEGREES			
					local vel = math.max( math.sqrt((self.tail_vel.x * self.tail_vel.x) + (self.tail_vel.z * self.tail_vel.z)) - (TAIL_ACC_MAX*dt) , 0)
					self.tail_vel = Vector3(vel * math.cos( angle ), 0, -vel * math.sin( angle ))
				end
				self.tail.Transform:SetPosition(pos.x+(self.tail_vel.x * dt),0,pos.z+(self.tail_vel.z *dt)	)

				-- set rotations
				local headpos =Vector3(self.head.Transform:GetWorldPosition())

						-- body rotation has velocity. 
						local body_angular_vel_max = 36/3
						if not self.body_angle_vel then
							self.body_angle_vel = 0
						end
						
						local targetAngle = self.inst:GetAngleToPoint(headpos)
						local currentAngle = self.inst.Transform:GetRotation()
					
						if math.abs(anglediff( currentAngle, targetAngle)) < 20 then

							if self.body_angle_vel > 0 then
								self.body_angle_vel = math.max(0, self.body_angle_vel - (self.angular_body_acc *dt))
							elseif self.body_angle_vel < 0 then
								self.body_angle_vel = math.min(0, self.body_angle_vel + (self.angular_body_acc *dt))
							end
							
						else
							if targetAngle > currentAngle then
								if targetAngle - currentAngle < 180 then
									self.body_angle_vel = math.min(body_angular_vel_max, self.body_angle_vel + (self.angular_body_acc *dt))
								else
									self.body_angle_vel = math.max(-body_angular_vel_max, self.body_angle_vel - (self.angular_body_acc *dt))
								end
							else
								if currentAngle - targetAngle < 180 then
									self.body_angle_vel = math.max(-body_angular_vel_max, self.body_angle_vel - (self.angular_body_acc *dt))							
								else
									self.body_angle_vel = math.min(body_angular_vel_max, self.body_angle_vel + (self.angular_body_acc *dt))
								end						
							end
						end 

						--print("self.body_angle_vel",self.body_angle_vel)
						currentAngle = currentAngle + (self.body_angle_vel*dt)			
						self.inst.Transform:SetRotation( currentAngle )
				
				if not self.head.sg:HasStateTag("busy") then
					local targetpos =Vector3(target.Transform:GetWorldPosition())
					local angle = self.head:GetAngleToPoint(targetpos.x,targetpos.y,targetpos.z)
					self.head.Transform:SetRotation(angle)
				end

				--self.head.Transform:SetRotation(self.inst.Transform:GetRotation())	
				self.tail.Transform:SetRotation(self.inst.Transform:GetRotation())	

				-- LEGS
				if not self.leg1.sg:HasStateTag("walking") and not self.leg2.sg:HasStateTag("walking") then

					local legdir = PI/2
					if self.currentleg == 2 then
						legdir = legdir * -1
					end

					local angle = self.inst.Transform:GetRotation()*DEGREES

					local currentlegtargetpos = Vector3(self.inst.Transform:GetWorldPosition()) + Vector3(LEGDIST * math.cos( angle+legdir ), 0, -LEGDIST * math.sin( angle+legdir ))
					local legdistsq = self.currentleg:GetDistanceSqToPoint(currentlegtargetpos)
					local anglediff =  anglediff(self.currentleg.Transform:GetRotation(), self.inst.Transform:GetRotation())
					if legdistsq > LEG_WALKDIST * LEG_WALKDIST or anglediff > self.turn_threshold then

						if legdistsq < LEG_WALKDIST_BIG*LEG_WALKDIST_BIG  or (anglediff > self.turn_threshold and legdistsq <= LEG_WALKDIST_BIG*LEG_WALKDIST_BIG ) then
							self.currentleg:PushEvent("walkfast")
						else
							self.currentleg:PushEvent("walk")
						end
															
						if self.currentleg == self.leg1 then
							self.currentleg = self.leg2
						else
							self.currentleg = self.leg1
						end
					end			
				end
			else
				self.inst:PushEvent("liftoff")
			end
			-- move tail to point in position like head. 
		end
	end

end

end)



AddComponentPostInit("bigfooter", function(self)

local _SummonFoot = self.SummonFoot
function self:SummonFoot(pos)
    --_SummonFoot(self, pos)
	local x, y, z = GetPlayer().Transform:GetWorldPosition()
    local canopy = TheSim:FindEntities(x,y,z, TUNING.SHADE_CANOPY_RANGE_SMALL, {"shadecanopysmall"})	
	if not TheCamera.interior and #canopy <= 0 then
		local world = GetWorld()
		if world:IsCave() then
			if world.components.quaker then
				world:DoTaskInTime(2, function(world)
					world.components.quaker:ForceQuake(5)
				end)
			end
		else
			self:SetTravelDirection()
			self.targetPos = pos
			self.stepNum = -self.numWarnings
			self.inst:StartUpdatingComponent(self)
		end
	end
end

end)


local function ReplenishFern(inst)
    if math.random() < 0.5 then
        local pt = inst:GetPosition()
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local range = 8 + math.random()*12
        local angle =  math.random() * 2 * PI
        local offset = FindWalkableOffset(pt, angle, range, 50, true, false)
        local x, y, z = GetPlayer().Transform:GetWorldPosition()
        local fern_amount = TheSim:FindEntities(pos.x, pos.y, pos.z, 100, {"fern_plant"}, {"fire"})
	
        if offset and #fern_amount < 1 then
            local newpoint = pt+offset
            if GetPlayer():GetDistanceSqToPoint(newpoint) > 40*40 then
                for i=1, math.random(12,20) do
                    range = math.random()*8
                    angle = math.random() * 2 * PI
                    local suboffset = FindWalkableOffset(newpoint, angle, range, 50, true, false)
                    local fern = SpawnPrefab("deep_jungle_fern_noise_plant")
                    local spawnpt = newpoint + suboffset
                    fern.Transform:SetPosition(spawnpt.x,spawnpt.y,spawnpt.z)
 				    local tiletype = GetGroundTypeAtPosition(fern:GetPosition())
				    if fern:GetIsOnWater() or tiletype ~= GROUND.DEEPRAINFOREST then
				        fern:Remove()
				    end    					
                end
            end
        end
	end
end

local function ReplenishNettle(inst)
	
    if GetSeasonManager() and GetSeasonManager():IsHumidSeason() and math.random() < 0.1 then
        local pt = inst:GetPosition()
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local range = 5 + math.random()*50
        local angle = math.random() * 2 * PI
        local offset = FindWalkableOffset(pt, angle, range, 100, true, false)
        local x, y, z = GetPlayer().Transform:GetWorldPosition()
        local nettle_amount = TheSim:FindEntities(pos.x, pos.y, pos.z, 100, {"nettle_plant"}, {"fire", "burnt", "stump"})
		local nettle_dug_amount = TheSim:FindEntities(pos.x, pos.y, pos.z, 100, {"dug_nettle"}, {"fire", "burnt", "stump"})
	
        if offset and #nettle_amount < 1 and #nettle_dug_amount < 5 then
            local newpoint = pt+offset
            if GetPlayer():GetDistanceSqToPoint(newpoint) > 100*100 then
                for i=1, math.random(2,3) do
                    range = math.random()*8
                    angle =  math.random() * 2 * PI
                    local suboffset = FindWalkableOffset(newpoint, angle, range, 100, true, false)
                    --local nettle = SpawnPrefab("nettle")
					local dugnettle = SpawnPrefab("dug_nettle")
                    local spawnpt = newpoint + suboffset
                    dugnettle.Transform:SetPosition(spawnpt.x,spawnpt.y,spawnpt.z)
				    local tiletype = GetGroundTypeAtPosition(dugnettle:GetPosition())
				    if tiletype ~= GROUND.DEEPRAINFOREST then
				        dugnettle:Remove()
				    end                    
                end
            end
        end
	end		
	
end


local function OnPhaseChanged(inst)
    if GetClock():IsDay() then
        local x, y, z = inst.Transform:GetWorldPosition()
        local fireflies_amount = TheSim:FindEntities(x,y,z, TUNING.SHADE_CANOPY_RANGE, {"firefly"})
        if #fireflies_amount < 10 then
            if math.random() < 0.7 then
                local pos = nil
                local offset = nil
                local count = 0
                while offset == nil and count < 10 do
                    local angle = 2*PI*math.random()
                    local radius = math.random() * (TUNING.SHADE_CANOPY_RANGE-4)
                    offset = {x= math.cos(angle) * radius, y=0, z=math.sin(angle) * radius}   
                    count = count + 1

                    pos = {x=x+offset.x, y=0, z=z+offset.z}

                    if #TheSim:FindEntities(pos.x, pos.y, pos.z, 5) > 0 then
                        offset = nil
                    end
                end
                if offset then
                    local firefly = SpawnPrefab("fireflies")
                    firefly.Transform:SetPosition(x+offset.x,0,z+offset.z)
					local tiletype = GetGroundTypeAtPosition(firefly:GetPosition())
					if not firefly:IsOnValidGround() or tiletype ~= GROUND.DEEPRAINFOREST then
					    firefly:Remove()
					end
                end
            end
        end
    end
end


local SHAKE_DIST = 40

local function HitShake(inst)
    local player = GetClosestInstWithTag("player", inst, SHAKE_DIST)
    if player then    
        player.components.playercontroller:ShakeCamera(inst, "VERTICAL", 2.8, 0.025, 0.3, SHAKE_DIST)
    end    
end

local function addtags_canopy_resources(inst)
    inst:AddTag("canopy_resources")
end

AddPrefabPostInit("cutgrass", addtags_canopy_resources)
AddPrefabPostInit("twigs", addtags_canopy_resources)
AddPrefabPostInit("foliage", addtags_canopy_resources)
AddPrefabPostInit("burr", addtags_canopy_resources)
AddPrefabPostInit("dug_nettle", addtags_canopy_resources)

local function SpawnMissingVines(inst)
    local x, _, z = inst.Transform:GetWorldPosition()
    local ents = TheSim:FindEntities(x, 0, z, TUNING.SHADE_CANOPY_RANGE+TUNING.TREE_PILLAR_CANOPY_BUFFER, { "hangingvine" })
    local num_existing_vines = ents ~= nil and #ents or 0

    if num_existing_vines < 4+ math.random(1,2)-1  then 

        local num_new_vines = math.random(1,2)
        local radius_variance = TUNING.SHADE_CANOPY_RANGE+TUNING.TREE_PILLAR_CANOPY_BUFFER - 6

        for i=1,num_new_vines do
            local vine = math.random() < 0.25 and SpawnPrefab("grabbing_vine") or SpawnPrefab("hanging_vine")
            local theta = math.random() * PI * 2
            local offset = 6 + radius_variance * math.random()
            vine.Transform:SetPosition(x + math.cos(theta) * offset, 0, z + math.sin(theta) * offset)
			local tiletype = GetGroundTypeAtPosition(vine:GetPosition())
			if not vine:IsOnValidGround() or (tiletype ~= GROUND.DEEPRAINFOREST and tiletype ~= GROUND.GASJUNGLE) then
				vine:Remove()
			end
        end
    end
end


local function SpawnCanopyMob(inst)
    local x, _, z = inst.Transform:GetWorldPosition()
    local ents = TheSim:FindEntities(x, 0, z, TUNING.SHADE_CANOPY_RANGE+TUNING.TREE_PILLAR_CANOPY_BUFFER, { "canopymob" })
    local num_existing_mobs = ents ~= nil and #ents or 0

    if num_existing_mobs < 5+ math.random(1,2)-1  then 

        local num_new_mobs = math.random(2,3)
        local radius_variance = TUNING.SHADE_CANOPY_RANGE+TUNING.TREE_PILLAR_CANOPY_BUFFER - 6

        for i=1,num_new_mobs do
            local canopymobs = {"mean_flytrap", "grabbing_vine", "spider_monkey"}
			
		    if GetSeasonManager() then
		        if GetSeasonManager():IsHumidSeason() then
		            canopymobs = {"mean_flytrap", "grabbing_vine", "spider_monkey", "rabid_beetle"}
		        end
		    end
			
			local mob = SpawnPrefab(GetRandomItem(canopymobs))
            local theta = math.random() * PI * 2
            local offset = 6 + radius_variance * math.random()
            mob.Transform:SetPosition(x + math.cos(theta) * offset, 0, z + math.sin(theta) * offset)
			if mob.components.combat ~= nil then
			    mob.components.combat:SuggestTarget(GetPlayer())
			end
			local tiletype = GetGroundTypeAtPosition(mob:GetPosition())
			if not mob:IsOnValidGround() or (tiletype ~= GROUND.DEEPRAINFOREST and tiletype ~= GROUND.GASJUNGLE) then
				mob:Remove()
			end
        end
    end
end

local function DropCanopyMobs(inst)
    local x, _, z = inst.Transform:GetWorldPosition()
    local ents = TheSim:FindEntities(x, 0, z, TUNING.SHADE_CANOPY_RANGE+TUNING.TREE_PILLAR_CANOPY_BUFFER, { "canopymob" })
    local num_existing_mobs = ents ~= nil and #ents or 0

	local num_new_mobs = math.random(1,2)
    local radius_variance = TUNING.SHADE_CANOPY_RANGE+TUNING.TREE_PILLAR_CANOPY_BUFFER - 6
    for i=1,num_new_mobs do	
		local mob = math.random() < 0.25 and SpawnPrefab("scorpion") or SpawnPrefab("snake_amphibious")
        local theta = math.random() * PI * 2
        local offset = 6 + radius_variance * math.random()
        mob.Transform:SetPosition(x + math.cos(theta) * offset, 10, z + math.sin(theta) * offset)
		if mob.sg ~= nil then
		    mob.sg:GoToState("fall")
		end
		if mob.components.combat ~= nil then
			mob.components.combat:SuggestTarget(GetPlayer())
		end
		mob:DoTaskInTime(0, function()
			if not mob:IsOnValidGround() then
				local x, y, z = mob.Transform:GetWorldPosition()
				SpawnPrefab("splash_clouds_drop").Transform:SetPosition(x, y, z)
				mob:Remove()			    
			elseif mob:GetIsOnWater() then
			    if mob:HasTag("amphibious") then
				    local x, y, z = mob.Transform:GetWorldPosition()
				    SpawnPrefab("splash_water_drop").Transform:SetPosition(x, y, z)				
				else
				    local x, y, z = mob.Transform:GetWorldPosition()
				    SpawnPrefab("splash_water_sink").Transform:SetPosition(x, y, z)
					mob:Remove()
				end
			end
		end)
    end

end

local function CanTreePillarCollideWithOthers(inst, other)
	if other == nil 
	    or (not other:IsValid()) 
		or (not other.entity:IsVisible()) 
		or other:HasTag("INTERIOR_LIMBO")
		or other:HasTag("canopymob")
		or other.components.inventoryitem ~= nil
		or (other:IsInLimbo()) then
        return false
	end
    if other ~= GetPlayer() then
	    if other.components.locomotor ~= nil then
		    if not other.components.locomotor.disable then
			    return true
			end
		end
	else
	    local curr_speed = nil
	    if GetPlayer().components.locomotor ~= nil then
		    curr_speed = GetPlayer().components.locomotor:GetRunSpeed()
		end
		if curr_speed == nil then
		    return false
		elseif curr_speed >= TUNING.TREE_PILLAR_COLLIDE_REQUIRED_PLAYER_SPEED then -- 12
		    return true
		end
	end
	return false
end

local function oncollide(inst, other)

	--local pos = Vector3(inst.Transform:GetWorldPosition())
	--local vines_amount = TheSim:FindEntities(pos.x, pos.y, pos.z, TUNING.SHADE_CANOPY_RANGE, {"hangingvine"})
	--if #vines_amount < 1 then

	--end
	
    if not inst:HasTag("cooldown_on_collide") and CanTreePillarCollideWithOthers(inst, other) then
	
        --inst:DoTaskInTime(0.5, SpawnCanopyMob)
		inst:DoTaskInTime(0.30, DropCanopyMobs)
        inst:DoTaskInTime(0.65, SpawnMissingVines)

        if other then
	        HitShake(inst)
	    end

        if other and other == GetPlayer() then
	        local x, y, z = inst.Transform:GetWorldPosition()
		    local CanopyEnts = TheSim:FindEntities(x,y,z, TUNING.SHADE_CANOPY_RANGE, {"canopymob"})	
	        for k,v in pairs(CanopyEnts) do
			    if v.components.combat ~= nil then
				    v.components.combat:SuggestTarget(GetPlayer())
				end
			end
	    end

        for i=1, math.random(3,5) do
            local x, _, z = inst.Transform:GetWorldPosition()
	
            local canopy_resources = {"cutgrass", "twigs", "foliage"}
		
		    if GetSeasonManager() then
		        if GetSeasonManager():IsLushSeason() then
		            canopy_resources = {"cutgrass", "twigs", "foliage", "burr"}
		        end
		    end
		
            local item = SpawnPrefab(GetRandomItem(canopy_resources))
	
            local dist = 6 + 10 * math.random()
            local theta = math.random() * 2 * PI
 
            local spawn_x, spawn_z

            spawn_x, spawn_z = x + math.cos(theta) * dist, z + math.sin(theta) * dist
	 
            item.Transform:SetPosition(spawn_x, 10, spawn_z)
			item:DoTaskInTime(1, function()
			    if not item:IsOnValidGround() then
				    local x, y, z = item.Transform:GetWorldPosition()
				    SpawnPrefab("splash_clouds_drop").Transform:SetPosition(x, y, z)
				    item:Remove()			    
			    elseif item:GetIsOnWater() then
			        if item.components.floatable ~= nil then
				        item.components.floatable:OnHitWater()
				    else
				        local x, y, z = item.Transform:GetWorldPosition()
				        SpawnPrefab("splash_water_sink").Transform:SetPosition(x, y, z)
					    item:Remove()
				    end
			    end
			end)
        end

        local x, _, z = inst.Transform:GetWorldPosition()

        local treenutdist = 6 + 10 * math.random()
        local treenuttheta = math.random() * 2 * PI
 
        local treenutspawn_x, treenutspawn_z

        treenutspawn_x, treenutspawn_z = x + math.cos(treenuttheta) * treenutdist, z + math.sin(treenuttheta) * treenutdist

        if GetModConfigData("Tree Nut") ~= 0 then
            if GetSeasonManager() and GetSeasonManager():IsLushSeason() then
                if math.random() < GetModConfigData("Tree Nut") then
				    local tree_seed = SpawnPrefab("treenut")
		            tree_seed.Transform:SetPosition(treenutspawn_x, 10, treenutspawn_z)
                    tree_seed.components.heavyobstaclephysics:AddFallingStates()
                    tree_seed:PushEvent("startfalling")  
                    tree_seed.Physics:SetVel(0, 0, 0)
                    tree_seed.falltask = tree_seed:DoPeriodicTask(FRAMES, function()
                        local x, y, z = tree_seed.Transform:GetWorldPosition()
                        if y <= 0.2 then
                            tree_seed:PushEvent("stopfalling")
                            if tree_seed.falltask then
                                tree_seed.falltask:Cancel()
                                tree_seed.falltask = nil
                            end
						    if not tree_seed:IsOnValidGround() then
				                SpawnPrefab("splash_clouds_drop").Transform:SetPosition(x, y, z)
				                tree_seed:Remove()								
                            elseif tree_seed:GetIsOnWater(x, 0, z) then
                                SpawnPrefab("splash_water_sink").Transform:SetPosition(x, y, z)
                                tree_seed:Remove()
                            end
                        end
                    end)					
				end
		    end
        end
		
	    inst:AddTag("cooldown_on_collide")
		--GetModConfigData("Frequency")
	    inst.components.timer:StartTimer("cooldown_on_collide", GetModConfigData("Frequency"))
        inst:ListenForEvent("timerdone", function(inst, data) 
		    if inst:HasTag("cooldown_on_collide") then
			    inst:RemoveTag("cooldown_on_collide")
		    end
	    end)	
		
	end

end


local function OnSave(inst, data)
	
	if inst:HasTag("cooldown_on_collide") then
	    print("Save tag of cooldown_on_collide")
	    data.cooldown_on_collide = true
	end
	
	if inst.components.timer ~= nil then
	    if inst.components.timer:TimerExists("cooldown_on_collide") then
		    print("Save tree pillar timer time left")
		    data.timer_cooldown_on_collide = inst.components.timer:GetTimeLeft("cooldown_on_collide")
		end
	end
	
end

local function OnLoad(inst, data)
	
	if data ~= nil and data.cooldown_on_collide then
	    if not inst:HasTag("cooldown_on_collide") then
		    print("Add tag of cooldown_on_collide")
		    inst:AddTag("cooldown_on_collide")
		end
	end
	
	if data ~= nil and data.timer_cooldown_on_collide then
	    if inst.components.timer ~= nil then
		    if inst.components.timer:TimerExists("cooldown_on_collide") then
		        print("Load tree pillar timer time")
				inst.components.timer:SetTimeLeft("cooldown_on_collide", data.timer_cooldown_on_collide)
		        inst:ListenForEvent("timerdone", function(inst, data) 
			        if inst:HasTag("cooldown_on_collide") then
			            inst:RemoveTag("cooldown_on_collide")
			        end
		        end)				
		    else
			    print("Load tree pillar missing timer time")
			    inst.components.timer:StartTimer("cooldown_on_collide", data.timer_cooldown_on_collide)
		        inst:ListenForEvent("timerdone", function(inst, data) 
			        if inst:HasTag("cooldown_on_collide") then
			            inst:RemoveTag("cooldown_on_collide")
			        end
		        end)
		    end
		end
	end
	
end



AddPrefabPostInit("tree_pillar", function(inst)
    inst:AddTag("shadecanopy")
	inst:AddTag("plant")
    inst:AddComponent("distancefade")
    inst.components.distancefade:Setup(15,25)
    --GetModConfigData("Frequency")
	if SaveGameIndex and SaveGameIndex:IsModePorkland() then
	    --GetModConfigData("Frequency")
		if KnownModIndex:IsModEnabled("workshop-2480458348") then
		    inst:DoPeriodicTask(GetModConfigData("Frequency"), ReplenishFern)
		end
        inst:DoPeriodicTask(GetModConfigData("Frequency"), ReplenishNettle)
	    inst.Physics:SetCollisionCallback(oncollide)
		inst:ListenForEvent("daytime", function() OnPhaseChanged(inst) end, GetWorld())
	    inst:AddComponent("timer")

        if GetModConfigData("Stalk Spawn") ~= 0 and math.random() < 0.05 then
            inst:AddComponent("childspawner")
            inst.components.childspawner.childname = "mean_flytrap"
			inst.components.childspawner.rarechild = "spider_monkey"
			inst.components.childspawner.rarechildchance = TUNING.TREE_PILLAR_RARE_CHILD_CHANCE
            inst.components.childspawner:SetRegenPeriod(GetModConfigData("Stalk Spawn"))   --GetModConfigData("Stalk Spawn")
            inst.components.childspawner:SetSpawnPeriod(GetModConfigData("Stalk Spawn"))   --GetModConfigData("Stalk Spawn")
            inst.components.childspawner:SetMaxChildren(TUNING.TREE_PILLAR_MAXCHILDREN)
			inst.components.childspawner.spawnoffscreen = true
			inst.components.childspawner:StartSpawning()
        end

	    inst.OnSave = OnSave
        inst.OnLoad = OnLoad		
	end
end)


local function lilypondspawn(inst)

    if math.random() < 0.2 then
        local pt = inst:GetPosition()
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local range = 5 + math.random()*10
        local angle =  math.random() * 2 * PI
        local offset = FindWalkableOffset(pt, angle, range, 10, true, false)
        local x, y, z = GetPlayer().Transform:GetWorldPosition()
        local reeds_amount = TheSim:FindEntities(pos.x, pos.y, pos.z, 30, {"water_reeds"})
	
        if offset and #reeds_amount < 8 then
            local newpoint = pt+offset
            if GetPlayer():GetDistanceSqToPoint(newpoint) > 40*40 then
                range = math.random()*8
                angle =  math.random() * 2 * PI
                local suboffset = FindWalkableOffset(newpoint, angle, range, 10, true, false)
                local reeds = SpawnPrefab("reeds_water")
                local spawnpt = newpoint + suboffset
                reeds.Transform:SetPosition(spawnpt.x,spawnpt.y,spawnpt.z) 
				if reeds.components.pickable ~= nil then
                    reeds.components.pickable:MakeEmpty()	
				end
				if not reeds:GetIsOnWater() then
				    reeds:Remove()
				end
            end
        end
	end	

    if math.random() < 0.1 then
        local pt = inst:GetPosition()
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local range = 5 + math.random()*10
        local angle =  math.random() * 2 * PI
        local offset = FindWalkableOffset(pt, angle, range, 10, true, false)
        local x, y, z = GetPlayer().Transform:GetWorldPosition()
        local fish_amount = TheSim:FindEntities(pos.x, pos.y, pos.z, 25, {"fishmeat"})
	
        if offset and #fish_amount < 3 then
            local newpoint = pt+offset
            if GetPlayer():GetDistanceSqToPoint(newpoint) > 40*40 then
                range = math.random()*8
                angle =  math.random() * 2 * PI
                local suboffset = FindWalkableOffset(newpoint, angle, range, 10, true, false)
                local fish = SpawnPrefab("fish")
                local spawnpt = newpoint + suboffset
                fish.Transform:SetPosition(spawnpt.x,spawnpt.y,spawnpt.z)
				if not fish:GetIsOnWater() then
				    fish:Remove()
				end	
            end
        end
	end	

    if math.random() < 0.05 then
        local pt = inst:GetPosition()
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local range = 5 + math.random()*10
        local angle =  math.random() * 2 * PI
        local offset = FindWalkableOffset(pt, angle, range, 10, true, false)
        local x, y, z = GetPlayer().Transform:GetWorldPosition()
        local lilypad_amount = TheSim:FindEntities(pos.x, pos.y, pos.z, 50, {"lilypad"})
	
        if offset and #lilypad_amount < 3 then   --including oneself
            local newpoint = pt+offset
            if GetPlayer():GetDistanceSqToPoint(newpoint) > 40*40 then
                range = math.random()*8
                angle =  math.random() * 2 * PI
                local suboffset = FindWalkableOffset(newpoint, angle, range, 10, true, false)
                local lilypad = SpawnPrefab("lilypad")
                local spawnpt = newpoint + suboffset
                lilypad.Transform:SetPosition(spawnpt.x,spawnpt.y,spawnpt.z) 
				if not lilypad:GetIsOnWater() then
				    lilypad:Remove()
				end				
            end
        end
	end	
	
    if math.random() < 0.01 then
        local pt = inst:GetPosition()
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local range = 5 + math.random()*10
        local angle =  math.random() * 2 * PI
        local offset = FindWalkableOffset(pt, angle, range, 10, true, false)
        local x, y, z = GetPlayer().Transform:GetWorldPosition()
        local lotus_amount = TheSim:FindEntities(pos.x, pos.y, pos.z, 50, {"lotus"})
	
        if offset and #lotus_amount < 3 then
            local newpoint = pt+offset
            if GetPlayer():GetDistanceSqToPoint(newpoint) > 40*40 then
                range = math.random()*8
                angle =  math.random() * 2 * PI
                local suboffset = FindWalkableOffset(newpoint, angle, range, 10, true, false)
                local lotus = SpawnPrefab("lotus")
                local spawnpt = newpoint + suboffset
                lotus.Transform:SetPosition(spawnpt.x,spawnpt.y,spawnpt.z)
				if lotus.components.pickable ~= nil then
                    lotus.components.pickable:MakeEmpty()
				end
				if not lotus:GetIsOnWater() then
				    lotus:Remove()
				end
            end
        end
	end		
	
    if math.random() <= 1 then
        local pt = inst:GetPosition()
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local range = 3 + math.random()*10
        local angle =  math.random() * 2 * PI
        local offset = FindWalkableOffset(pt, angle, range, 10, true, false)
        local x, y, z = GetPlayer().Transform:GetWorldPosition()
        local relic_amount = TheSim:FindEntities(pos.x, pos.y, pos.z, 25, {"relic"})
	
        if offset and #relic_amount < 3 then
            local newpoint = pt+offset
            if GetPlayer():GetDistanceSqToPoint(newpoint) > 40*40 then
			    --print("spawn!!!")
                range = math.random()*5
                angle = math.random() * 2 * PI
                local suboffset = FindWalkableOffset(newpoint, angle, range, 10, true, false)
				local all_relics = {"relic_1", "relic_2", "relic_3"}
                local relic = SpawnPrefab(GetRandomItem(all_relics))
                local spawnpt = newpoint + suboffset
                relic.Transform:SetPosition(spawnpt.x,spawnpt.y,spawnpt.z)
				if not relic:GetIsOnWater() then
				    relic:Remove()
				else 
				    if relic.components.floatable ~= nil and relic.components.sinkable ~= nil then
					    relic.components.floatable:OnHitWater()
					else
					    relic:Remove()
					end
				end
            end
        end
	end		

end

AddPrefabPostInit("lilypad", function(inst)
    inst:AddTag("lilypad")
    --GetModConfigData("Frequency")
	if SaveGameIndex and SaveGameIndex:IsModePorkland() then
	    if GetModConfigData("Lily Pond Refresh") ~= 0 then
	        inst:DoPeriodicTask(GetModConfigData("Lily Pond Refresh"), lilypondspawn)
		end
	end
end)

local function addtagspinacle_plant(inst)
    inst:AddTag("pinacle_plant")
end

AddPrefabPostInit("roc_nest_tree1", addtagspinacle_plant)
AddPrefabPostInit("roc_nest_tree2", addtagspinacle_plant)
AddPrefabPostInit("roc_nest_bush", addtagspinacle_plant)
AddPrefabPostInit("roc_nest_branch1", addtagspinacle_plant)
AddPrefabPostInit("roc_nest_branch2", addtagspinacle_plant)
AddPrefabPostInit("roc_nest_trunk", addtagspinacle_plant)
AddPrefabPostInit("roc_nest_debris1", addtagspinacle_plant)
AddPrefabPostInit("roc_nest_debris2", addtagspinacle_plant)
AddPrefabPostInit("roc_nest_debris3", addtagspinacle_plant)
AddPrefabPostInit("roc_nest_debris4", addtagspinacle_plant)

local function PinaclePlantsSpawn(inst)

    if math.random() < 0.5 then
        local pt = inst:GetPosition()
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local range = 5 + math.random()*50
        local angle = math.random() * 2 * PI
        local offset = FindWalkableOffset(pt, angle, range, 100, true, false)
        local x, y, z = GetPlayer().Transform:GetWorldPosition()
        local pinacle_plant_amount = TheSim:FindEntities(pos.x, pos.y, pos.z, 1000, {"pinacle_plant"}, {"burnt", "stump"})
	
        if offset and #pinacle_plant_amount < 30 then
		    --print("Find offset!!!")
            local newpoint = pt+offset
            if GetPlayer():GetDistanceSqToPoint(newpoint) > 100*100 then
                range = math.random()*8
                angle = math.random() * 2 * PI
                local suboffset = FindWalkableOffset(newpoint, angle, range, 100, true, false)
				local pinacle_plant = 
				{ 
				    "roc_nest_tree1", 
			    	"roc_nest_tree2", 
			    	"roc_nest_bush", 
			    	"roc_nest_branch1", 
			    	"roc_nest_branch2", 
			    	"roc_nest_trunk", 
		    		"roc_nest_debris1", 
		    		"roc_nest_debris2", 
		    		"roc_nest_debris3", 
		    		"roc_nest_debris4",
				}
                local plant = SpawnPrefab(GetRandomItem(pinacle_plant))
                local spawnpt = newpoint + suboffset
				--print("spawn!!!")
                plant.Transform:SetPosition(spawnpt.x,spawnpt.y,spawnpt.z)
				if not plant:IsOnValidGround() or plant:GetIsOnWater() then
				    plant:Remove()
				end
            end
        end
	end	

end


local function TuberTreeSeedSpawn(inst)

    if inst.build == "blooming" and not inst:HasTag("burnt") and not inst:HasTag("stump") then
        local pt = inst:GetPosition()
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local range = 3 + math.random()*10
        local angle = math.random() * 2 * PI
        local offset = FindWalkableOffset(pt, angle, range, 20, true, false)
        local x, y, z = GetPlayer().Transform:GetWorldPosition()
        local tuber_seed_amount = TheSim:FindEntities(pos.x, pos.y, pos.z, 50, {"tuber_tree_seed"}, {"fire", "burnt", "INLIMBO"})
	
        if offset and #tuber_seed_amount < 10 then
		    --print("Find offset!!!")
            local newpoint = pt+offset
            if GetPlayer():GetDistanceSqToPoint(newpoint) > 20*20 then
                range = math.random()*5
                angle = math.random() * 2 * PI
                local suboffset = FindWalkableOffset(newpoint, angle, range, 20, true, false)
                local seed = SpawnPrefab("tuber_pollen")
                local spawnpt = newpoint + suboffset
				--print("spawn!!!")
                seed.Transform:SetPosition(spawnpt.x,spawnpt.y,spawnpt.z)
				if not seed:IsOnValidGround() then
				    seed:Remove()
				elseif seed:GetIsOnWater() then
			        if seed.components.floatable ~= nil then
				        seed.components.floatable:OnHitWater()
				    else
					    seed:Remove()
				    end
				end
            end
        end	 
	end

end

AddPrefabPostInit("roc_nest", function(inst)
    --inst:AddTag("roc_nest")
    --GetModConfigData("Frequency")
	if SaveGameIndex and SaveGameIndex:IsModePorkland() then
	    if GetModConfigData("Pinacle Refresh") ~= 0 then
	        inst:DoPeriodicTask(GetModConfigData("Pinacle Refresh"), PinaclePlantsSpawn)
		end
	end
end)

local function bloomoutofhamlet(inst)
    if inst.components.bloomable ~= nil then
        inst.components.bloomable.season = {SEASONS.LUSH, SEASONS.GREEN, SEASONS.SPRING}
    end
end

AddPrefabPostInit("rainforesttree", bloomoutofhamlet)
AddPrefabPostInit("tubertree", bloomoutofhamlet)

AddPrefabPostInit("tubertree", function(inst)
    --GetModConfigData("Frequency")
	--if SaveGameIndex and SaveGameIndex:IsModePorkland() then
	    inst:DoPeriodicTask(GetModConfigData("Frequency"), TuberTreeSeedSpawn)
	--end
end)

AddPrefabPostInit("clawpalmtree", function(inst)
    if GetModConfigData("Pog Spawn") ~= 0 and math.random() < 0.05 then
        inst:AddComponent("childspawner")
        inst.components.childspawner.childname = "pog"
        inst.components.childspawner:SetRegenPeriod(GetModConfigData("Pog Spawn"))   --GetModConfigData("Pog Spawn")
        inst.components.childspawner:SetSpawnPeriod(GetModConfigData("Pog Spawn"))   --GetModConfigData("Pog Spawn")
        inst.components.childspawner:SetMaxChildren(TUNING.CLAW_PALM_TREE_MAXCHILDREN)
		inst.components.childspawner.spawnoffscreen = false
		inst.components.childspawner.CanSpawn = function(self) 
            if self.childreninside <= 0 then
                return false
            end
    
            if inst:IsAsleep() and not self.spawnoffscreen then
		        return false
            end
    
            if not inst:IsValid() then
                return false
            end
   
		    if inst:HasTag("burnt") or inst:HasTag("stump") then
			    return false
			end		
			local tiletype = GetWorld().Map:GetTileAtPoint(inst.Transform:GetWorldPosition())
		    return tiletype == GROUND.PLAINS 	
		end
		inst.components.childspawner:StartSpawning()
    end
end)

AddComponentPostInit("mystery", function(self)

--local _GenerateReward = self.GenerateReward 
function self:GenerateReward()
    --_GenerateReward(self)
	local mid_tier = {"flint", "goldnugget", "oinc", "oinc10"}
	for i=1,NUM_TRINKETS do
		table.insert(mid_tier, "trinket_" .. tostring(i))
	end

	local high_tier = {"trinket_giftshop_1","trinket_giftshop_3","trinket_giftshop_4","sunken_boat_trinket_4","honeycomb"}
	for i=1,3 do
		table.insert(high_tier, "relic_" .. tostring(i))
	end

	if math.random() < 0.4 then
    	return nil
	elseif math.random() < 0.7 then
		return mid_tier[math.random(#mid_tier)]
	else
		return high_tier[math.random(#high_tier)]
	end	
end

end)

local function AddTagsForCaveFlower(inst)
    inst:AddTag("plant")
	inst:AddTag("caveflower")
end

AddPrefabPostInit("flower_cave", AddTagsForCaveFlower)
AddPrefabPostInit("flower_cave_double", AddTagsForCaveFlower)
AddPrefabPostInit("flower_cave_triple", AddTagsForCaveFlower)

local function AddTagsForMushTree(inst)
    inst:AddTag("plant")
	inst:AddTag("shelter")
	inst:AddTag("mushtree")
end

AddPrefabPostInit("mushtree_tall", AddTagsForMushTree)
AddPrefabPostInit("mushtree_medium", AddTagsForMushTree)
AddPrefabPostInit("mushtree_small", AddTagsForMushTree)

local function AddTagsForCaveFern(inst)
	inst:AddTag("cavefern") 
end

AddPrefabPostInit("cave_fern", AddTagsForCaveFern)

local function ReplenishIndoorsCavePlants(inst)

    --To DO: Make Spwan of Indoors Right

    if math.random() < 0.5 then
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local CaveFlowerAmount = TheSim:FindEntities(pos.x, pos.y, pos.z, 50, {"caveflower"})
        if #CaveFlowerAmount < 1 then
            local x, _, z = inst.Transform:GetWorldPosition()
            local x_dist = (math.random() * TUNING.ROOM_TINY_DEPTH) - TUNING.ROOM_TINY_DEPTH/2         --10
			local z_dist = (math.random() * TUNING.ROOM_LARGE_DEPTH) - TUNING.ROOM_LARGE_DEPTH/2       --18
            local subtheta = math.random() * 2 * PI
            local spawn_x, spawn_z
            spawn_x, spawn_z = x + math.cos(subtheta) * x_dist, z + math.sin(subtheta) * z_dist	  			        
			local BlockerNearby = TheSim:FindEntities(spawn_x, 0, spawn_z, 3)
			if #BlockerNearby <= 0 then
			    local flower = (math.random() < 0.1 and SpawnPrefab("flower_cave_triple")) or (math.random() < 0.25 and SpawnPrefab("flower_cave_double")) or SpawnPrefab("flower_cave")
				print("Try To Spawn Cave Flower Indoors")
                flower.Transform:SetPosition(spawn_x, 0, spawn_z)
				if not flower:IsOnValidGround() or flower:GetIsOnWater() then
				    flower:Remove()
			    end
			end
        end	 
	end
	
    if math.random() < 0.75 then
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local MushTreeAmount = TheSim:FindEntities(pos.x, pos.y, pos.z, 50, {"mushtree"})
        if #MushTreeAmount < 1 then
            local x, _, z = inst.Transform:GetWorldPosition()
            local x_dist = (math.random() * TUNING.ROOM_TINY_DEPTH) - TUNING.ROOM_TINY_DEPTH/2         --10
			local z_dist = (math.random() * TUNING.ROOM_LARGE_DEPTH) - TUNING.ROOM_LARGE_DEPTH/2       --18
            local subtheta = math.random() * 2 * PI
            local spawn_x, spawn_z
            spawn_x, spawn_z = x + math.cos(subtheta) * x_dist, z + math.sin(subtheta) * z_dist	  			        
			local BlockerNearby = TheSim:FindEntities(spawn_x, 0, spawn_z, 3)
			if #BlockerNearby <= 0 then
			    local tree_types = {"mushtree_tall", "mushtree_medium", "mushtree_small"}
			    local tree = SpawnPrefab(GetRandomItem(tree_types))
				print("Try To Spawn Mushtree Indoors")
                tree.Transform:SetPosition(spawn_x, 0, spawn_z)
				if not tree:IsOnValidGround() or tree:GetIsOnWater() then
				    tree:Remove()
			    end
			end
        end	 
	end
	
    if math.random() <= 1 then
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local CaveFernAmount = TheSim:FindEntities(pos.x, pos.y, pos.z, 50, {"cavefern"})
        if #CaveFernAmount < 10 then
            local x, _, z = inst.Transform:GetWorldPosition()
            local x_dist = (math.random() * TUNING.ROOM_TINY_DEPTH) - TUNING.ROOM_TINY_DEPTH/2         --10
			local z_dist = (math.random() * TUNING.ROOM_LARGE_DEPTH) - TUNING.ROOM_LARGE_DEPTH/2       --18
            local subtheta = math.random() * 2 * PI
            local spawn_x, spawn_z
            spawn_x, spawn_z = x + math.cos(subtheta) * x_dist, z + math.sin(subtheta) * z_dist	  			        
			local BlockerNearby = TheSim:FindEntities(spawn_x, 0, spawn_z, 1.5)
			if #BlockerNearby <= 0 then
			    local fern = SpawnPrefab("cave_fern")
				print("Try To Spawn Cave Fern Indoors")
                fern.Transform:SetPosition(spawn_x, 0, spawn_z)
				if not fern:IsOnValidGround() or fern:GetIsOnWater() then
				    fern:Remove()
			    end
			end
        end	 
	end	
	
end

local function ReplenishLightFlower(inst)
    if math.random() < 0.5 then
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local CaveFlowerAmount = TheSim:FindEntities(pos.x, pos.y, pos.z, 50, {"caveflower"})
        if #CaveFlowerAmount < 3 then
            local x, _, z = inst.Transform:GetWorldPosition()
            local x_dist = 5 + 10 * math.random()         
			local z_dist = 3 + 12 * math.random()               
            local subtheta = math.random() * 2 * PI
            local spawn_x, spawn_z
            spawn_x, spawn_z = x + math.cos(subtheta) * x_dist, z + math.sin(subtheta) * z_dist	  			        
			local BlockerNearby = TheSim:FindEntities(spawn_x, 0, spawn_z, 3)
			if #BlockerNearby <= 0 then
			    local flower = (math.random() > 0.1 and SpawnPrefab("flower_cave")) or (math.random() > 0.25 and SpawnPrefab("flower_cave_double")) or SpawnPrefab("flower_cave_triple")
				--print("Try To Spawn Cave Flower")
                flower.Transform:SetPosition(spawn_x, 0, spawn_z)
				if not inst:IsAsleep() and not inst:IsInLimbo() then
				    local fx = SpawnPrefab("splash_water_drop")
					fx.Transform:SetPosition(spawn_x, 0, spawn_z)
					fx.Transform:SetScale(1.5, 1.5, 1.5)
				end
				if not flower:IsOnValidGround() or flower:GetIsOnWater() then
				    flower:Remove()
			    end
			end
        end	 
	end
end

local function ReplenishMushtree(inst)
    if math.random() < 0.75 then
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local MushTreeAmount = TheSim:FindEntities(pos.x, pos.y, pos.z, 50, {"mushtree"})
        if #MushTreeAmount < 3 then
            local x, _, z = inst.Transform:GetWorldPosition()
            local x_dist = 5 + 10 * math.random()        
			local z_dist = 3 + 12 * math.random()        
            local subtheta = math.random() * 2 * PI
            local spawn_x, spawn_z
            spawn_x, spawn_z = x + math.cos(subtheta) * x_dist, z + math.sin(subtheta) * z_dist	  			        
			local BlockerNearby = TheSim:FindEntities(spawn_x, 0, spawn_z, 3)
			if #BlockerNearby <= 0 then
			    local tree_types = {"mushtree_tall", "mushtree_medium", "mushtree_small"}
			    local tree = SpawnPrefab(GetRandomItem(tree_types))
				--print("Try To Spawn Mushtree")
                tree.Transform:SetPosition(spawn_x, 0, spawn_z)
				if not inst:IsAsleep() and not inst:IsInLimbo() then
				    local fx = SpawnPrefab("splash_water_drop")
					fx.Transform:SetPosition(spawn_x, 0, spawn_z)
					fx.Transform:SetScale(1.5, 1.5, 1.5)
				end
				if not tree:IsOnValidGround() or tree:GetIsOnWater() then
				    tree:Remove()
			    end
			end
        end	 
	end
end

local function ReplenishCaveFern(inst)
    if math.random() <= 1 then
		local pos = Vector3(inst.Transform:GetWorldPosition())
        local CaveFernAmount = TheSim:FindEntities(pos.x, pos.y, pos.z, 50, {"cavefern"})
        if #CaveFernAmount < 10 then
            local x, _, z = inst.Transform:GetWorldPosition()
            local x_dist = 5 + 10 * math.random()        
			local z_dist = 3 + 12 * math.random()        
            local subtheta = math.random() * 2 * PI
            local spawn_x, spawn_z
            spawn_x, spawn_z = x + math.cos(subtheta) * x_dist, z + math.sin(subtheta) * z_dist	  			        
			local BlockerNearby = TheSim:FindEntities(spawn_x, 0, spawn_z, 3)
			if #BlockerNearby <= 0 then
			    local fern = SpawnPrefab("cave_fern")
				--print("Try To Spawn Cave Fern")
                fern.Transform:SetPosition(spawn_x, 0, spawn_z)
				if not inst:IsAsleep() and not inst:IsInLimbo() then
					SpawnPrefab("splash_water_drop").Transform:SetPosition(spawn_x, 0, spawn_z)
				end
				if not fern:IsOnValidGround() or fern:GetIsOnWater() then
				    fern:Remove()
			    end
			end
        end	 
	end	
end

local function Fountain_OnTimerDone(inst, data)
    if data ~= nil then
	    if data.name == "ReplenishLightFlower" then
		    ReplenishLightFlower(inst)
		end
	    if data.name == "ReplenishMushtree" then
		    ReplenishMushtree(inst)
		end
	    if data.name == "ReplenishCaveFern" then
		    ReplenishCaveFern(inst)
		end	
	    if data.name == "DropNiceStuff" then
		    if inst.components.lootdropper ~= nil then
			    if math.random() < 0.5 then
                    local x, _, z = inst.Transform:GetWorldPosition()
                    local x_dist = 2 + 3 * math.random()        
			        local z_dist = 1 + 4 * math.random()        
                    local subtheta = math.random() * 2 * PI
                    local spawn_x, spawn_z
                    spawn_x, spawn_z = x + math.cos(subtheta) * x_dist, z + math.sin(subtheta) * z_dist	
			        local BlockerNearby = TheSim:FindEntities(spawn_x, 0, spawn_z, 3)
			        if #BlockerNearby <= 0 then					
			            inst.components.lootdropper:DropLoot(Vector3(spawn_x, 4, spawn_z))
						if not inst:IsAsleep() and not inst:IsInLimbo() then
						    SpawnPrefab("splash_water_drop").Transform:SetPosition(spawn_x, 4, spawn_z)
						end
					end
				end
			end
		end			
	end
end

local function CheckIfFountainDry(inst)
    if inst.components.timer == nil then
	    return
	end
    if inst.dry then
	    if inst.components.timer:TimerExists("ReplenishLightFlower") then
		    inst.components.timer:PauseTimer("ReplenishLightFlower")
		end
	    if inst.components.timer:TimerExists("ReplenishMushtree") then
		    inst.components.timer:PauseTimer("ReplenishMushtree")
		end
	    if inst.components.timer:TimerExists("ReplenishCaveFern") then
		    inst.components.timer:PauseTimer("ReplenishCaveFern")
		end	
	    if inst.components.timer:TimerExists("DropNiceStuff") then
		    inst.components.timer:PauseTimer("DropNiceStuff")
		end		
	else
	    if inst.components.timer:TimerExists("ReplenishLightFlower") then
		    inst.components.timer:ResumeTimer("ReplenishLightFlower")
		else
		    inst.components.timer:StartTimer("ReplenishLightFlower", 60)
		end
	    if inst.components.timer:TimerExists("ReplenishMushtree") then
		    inst.components.timer:ResumeTimer("ReplenishMushtree")
		else
		    inst.components.timer:StartTimer("ReplenishMushtree", 45)
		end
	    if inst.components.timer:TimerExists("ReplenishCaveFern") then
		    inst.components.timer:ResumeTimer("ReplenishCaveFern")
		else
		    inst.components.timer:StartTimer("ReplenishCaveFern", 30)
		end	
	    if inst.components.timer:TimerExists("DropNiceStuff") then
		    inst.components.timer:ResumeTimer("DropNiceStuff")
		else
		    inst.components.timer:StartTimer("DropNiceStuff", 15)
		end			
	end
end

AddPrefabPostInit("pugalisk_fountain", function(inst)
    --GetModConfigData("Frequency")
	if SaveGameIndex and SaveGameIndex:IsModePorkland() then
        if GetModConfigData("Fountain Spawn") == true then

		    inst:AddComponent("timer")

            inst:AddComponent("lootdropper")
			inst.components.lootdropper.speed = 5
	        inst.components.lootdropper:AddRandomLoot("cutgrass", 1.00)
	        inst.components.lootdropper:AddRandomLoot("twigs", 1.00)
	        inst.components.lootdropper:AddRandomLoot("rocks", 1.00)
			inst.components.lootdropper:AddRandomLoot("dug_sapling", 0.25)
			inst.components.lootdropper:AddRandomLoot("dug_grass", 0.25)
			inst.components.lootdropper:AddRandomLoot("dug_marsh_bush", 0.25)
	        inst.components.lootdropper.numrandomloot = 1
			
			inst:DoTaskInTime(0, function()
			    if not inst.dry then
			        inst.components.timer:StartTimer("ReplenishLightFlower", 60)
				    inst.components.timer:StartTimer("ReplenishMushtree", 45)
				    inst.components.timer:StartTimer("ReplenishCaveFern", 30)
					inst.components.timer:StartTimer("DropNiceStuff", 15)
			    end
			end)
			inst.CheckDryTask = inst:DoPeriodicTask(1, CheckIfFountainDry)
			inst:ListenForEvent("timerdone", Fountain_OnTimerDone)
			
		end
    end
end)

local function PickAnim(inst)
	if inst.components.pickable ~= nil then
		if inst.components.pickable:CanBePicked() then
			local percent = 0
			if inst.components.pickable ~= nil then
				percent = inst.components.pickable.cycles_left / inst.components.pickable.max_cycles
			end
			if percent >= .9 then
				return "berriesmost"
			elseif percent >= .33 then
				return "berriesmore"
			else
				return "berries"
			end
		else
			if inst.components.pickable:IsBarren() then
				return "idle_dead"
			else
				return "idle"
			end
		end
	end

	return "idle"
end

local function ShakeBush(inst)
	if inst.components.pickable ~= nil and inst.components.pickable:CanBePicked() then
		inst.AnimState:PlayAnimation("shake")
	else
		inst.AnimState:PlayAnimation("shake_empty")
	end
	inst.AnimState:PushAnimation(PickAnim(inst), false)
end

local function SpawnPerd(inst)
	if inst:IsValid() then
		local perd
		if SaveGameIndex:IsModePorkland() then 
			perd = SpawnPrefab("peagawk")
		elseif not SaveGameIndex:IsModeShipwrecked() then
			perd = SpawnPrefab("perd")
		end 
		if perd then 
			local spawnpos = Vector3(inst.Transform:GetWorldPosition() )
			spawnpos = spawnpos + TheCamera:GetDownVec()
			perd.Transform:SetPosition(spawnpos:Get() )
			perd.sg:GoToState("appear")
			if perd.components.homeseeker ~= nil then
			    perd.components.homeseeker:SetHome(inst)
			end
			ShakeBush(inst)
		end 
	end
end

local function PickBerries(inst)
	if inst.components.pickable ~= nil then
		local old_percent = (inst.components.pickable.cycles_left+1) / inst.components.pickable.max_cycles

		if old_percent >= .9 then
			inst.AnimState:PlayAnimation("berriesmost_picked")
		elseif old_percent >= .33 then
			inst.AnimState:PlayAnimation("berriesmore_picked")
		else
			inst.AnimState:PlayAnimation("berries_picked")
		end

		if inst.components.pickable:IsBarren() then
			inst.AnimState:PushAnimation("idle_dead")
		else
			inst.AnimState:PushAnimation("idle")
		end
	end	
end

local function OnBerryPickedFn(inst, picker)
	PickBerries(inst)
	
	if inst.spawnsperd and picker and not picker:HasTag("berrythief") and math.random() < TUNING.PERD_SPAWNCHANCE then
	 	inst:DoTaskInTime(3+math.random()*3, SpawnPerd)
	end
end

local function TryToSpawnPeagawkOnPicked(inst)
    if inst.components.pickable ~= nil then
        inst.components.pickable.onpickedfn = OnBerryPickedFn
    end
end

if GetModConfigData("Peagawk Spawn") == true then

AddPrefabPostInit("berrybush", TryToSpawnPeagawkOnPicked)
AddPrefabPostInit("berrybush2", TryToSpawnPeagawkOnPicked)

end

AddPrefabPostInit("world", function(inst)
    if not inst.components.shadowmanager then
	    inst:AddComponent("shadowmanager")
	end
end)




